#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
static double ***field;

/*--*/


int
init_getvalue (int unit, char *file)
{
  int nmbr;
  double step;
  double *malloc_3double ();
  double *malloc_1double ();
  int *malloc_1int ();
  FILE *fopen (), *fp;
  char projekt_dir[80];
  int i, j, k;
  int ret;
  char file2[100];
  char line[100];
  float dummy;
  float scalex, scaley;
  float x;
  static int *f;		/*how much fields in unit */
  static int flag = 1;
  int print = 0;
  double get_dvalue ();
  double get_value ();
  if (flag)
    {				/*malloc */
      f = malloc_1int (40);
      field = (double ***) malloc (sizeof (double) * 30);	/*erstmal 30 units */
      for (i = 0; i <= 30; i++)
	field[i] = (double **) malloc (sizeof (double) * 10);	/*mit je 10 Feldern */
      flag = 0;
    }

  f[unit]++;

  if ((ret = readlink ("current_project", projekt_dir, 80)) == -1)
    {
      fprintf (stderr, "no symbolic link to current projekt ! \n");
      exit (0);
    }
  projekt_dir[ret] = '\0';

  sprintf (file2, "%s%s", projekt_dir, file);

  if ((fp = fopen (file2, "r")) == NULL)
    {
      printf ("\n%s nicht da EXIT \n", file2);
      exit (0);
    }

  if (print)
    printf ("#Open %s\n", file2);
  printf ("Initializing getvalue for unit:%2d with file %s\n", unit, file2);
  i = 0;
  while (fgets (line, 200, fp) != NULL)
    {
      if (0)
	printf ("i%d\n", i);

      if (line[0] != '#')
	{
	  i++;
	  if (i == 1)
	    {
	      sscanf (line, "%d", &nmbr);
	      if (0)
		printf ("#unit %d fn %d -> Anzahl Sttzstellen: %d\n", unit,
			f[unit], nmbr);
	      field[unit][f[unit]] = (double *) malloc_1double (nmbr + 3);
	      field[unit][f[unit]][0] = (double) nmbr;
	    }
	  if (i == 2)
	    {
	      sscanf (line, "%f", &dummy);
	      if (0)
		printf ("#scalex %5.4f\n", dummy);
	      scalex = dummy;
	    }
	  if (i == 3)
	    {
	      sscanf (line, "%f", &dummy);
	      if (0)
		printf ("#scaley %5.4f\n", dummy);
	      scaley = dummy;
	    }
	  if (i == 4)
	    {
	      sscanf (line, "%f", &dummy);
	      if (0)
		printf ("#Step %5.4f\n", dummy);
	      field[unit][f[unit]][1] = dummy * scalex;
	      step = dummy * scalex;
	    }


	  if (i > 4)
	    {
	      sscanf (line, "%f", &dummy);
	      field[unit][f[unit]][i - 3] = dummy * scaley;
	      if (0)
		printf ("#%5.4e\n", dummy);
	    }
	  if (i > nmbr + 4)
	    {
	      printf ("Error, too many values !\n");
	      exit (0);
	    }
	}
    }				/*end while */

  if (print)
    {
      printf ("scalex %5.3e scaley %5.3e\nmax %5.3e \n#END init_getvalue()\n",
	      scalex, scaley, (i - 3) * step);
      for (x = 0.0; x <= (i - 3) * step; x += step)
	printf ("%5.3e -> %5.3e deriv-> %5.3e\n", x,
		get_value (unit, f[unit], x), get_dvalue (unit, f[unit], x));
    }

  return (f[unit]);
}

double
get_value (int unit, int f, double x)
{
  int i;
  double delt;
  double ret;
  double *fieldlocal;

  fieldlocal = field[unit][f];

  i = (int) (x / fieldlocal[1]);
  delt = x - i * fieldlocal[1];
  if (i >= fieldlocal[0] - 1)
    {
      i = fieldlocal[0] - 1;
      ret =
	fieldlocal[i + 2] + (delt / fieldlocal[1]) * (fieldlocal[i + 3] -
						      fieldlocal[i + 2]);
      return (ret);
    }


  ret =
    fieldlocal[i + 2] + (delt / fieldlocal[1]) * (fieldlocal[i + 3] -
						  fieldlocal[i + 2]);
/*
printf("x %4.3F I %d %4.3e ret= %6.5e field[i+2]=%5.4e\n",x,i,delt,ret,fieldlocal[i+2]);
*/
  return (ret);
}

double
get_dvalue (int unit, int f, double x)
{
/*fieldlocal[0] -> nmbr of values :: fieldlocal[1] -> step */
  int i;
  double delt;
  double ret;
  double *fieldlocal;

  fieldlocal = field[unit][f];

  i = (int) (x / fieldlocal[1]);
  if (i >= fieldlocal[0] - 1)
    {

      ret = 0.0;
      i = fieldlocal[0] - 1;
      ret = (fieldlocal[i + 3] - fieldlocal[i + 2]) / fieldlocal[1];
      return (ret);
    }
  ret = (fieldlocal[i + 3] - fieldlocal[i + 2]) / fieldlocal[1];
/*
 printf("ret %5.4e \n",ret);

printf("x %4.3F I %d %4.3e ret= %6.5e field[i+2]=%5.4e\n",x,i,delt,ret,fieldlocal[i+2]);
*/

  return (ret);
}
float getmaxvalue(int unit,int f){
 int i;
 float max=0.0;
   double *fieldlocal;

  fieldlocal = field[unit][f];

 for (i=0;i<(int) fieldlocal[0];i++){
     if (fieldlocal[i+2]> max) max=fieldlocal[i+2];
                                    }
 return(max);
}
float getminvalue(int unit,int f){
 int i;
 float min=1e30;
   double *fieldlocal;

  fieldlocal = field[unit][f];

 for (i=0;i<(int) fieldlocal[0];i++){
     if (fieldlocal[i+2]< min) min=fieldlocal[i+2];
                                    }
 return(min);
}


