/*
*compilieren mit make
*----
*/
#include "gl2ps.h"
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
/* GLUT & OpenGL Bibliotheken */
#include <GL/glut.h>
#include <GL/gl.h>

#define N 20
/*--shared*/
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>

#include "gl_global.h"
#include "gl_var.h"


void
init (void)
{

  GLfloat values[2];
  glGetFloatv (GL_LINE_WIDTH_GRANULARITY, values);
  if (0) printf ("GL_LINE_WIDTH_GRANULARITY value is %3.1f\n", values[0]);
  glGetFloatv (GL_LINE_WIDTH_RANGE, values);
  if (0) printf ("GL_LINE_WIDTH_RANGE values are %3.1f %3.1f\n",
	  values[0], values[1]);
  glEnable (GL_LINE_SMOOTH);
  glEnable (GL_BLEND);
  if (1)
    glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  if (0)
    glHint (GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
}
void
/*------------------------------------------*/
mouse (int btn, int state, int x, int y)
{
  if (state == GLUT_DOWN)
    {
      if ((btn == GLUT_LEFT_BUTTON) && (state == 0))
	{
	  mousemotion = 1;
	  xl = x;
	  yo = y;
	  xmov = x;
	  ymov = y;
	  fence = 1;
	}
    }
  if ((btn == GLUT_LEFT_BUTTON) && (state == 1))
    {
      xr = x;
      yu = y;
      fence = 2;
    }
}
/*------------------------------------------*/
void
motion (int x, int y)
{
  if (mousemotion)
    {
      if (0)
	printf ("%d %d \n", x, y);
      xmov = (float) x;
      ymov = (float) y;
    }
}
/*------------------------------------------*/
void
keyboard (unsigned char key_code, int xpos, int ypos)
{
  int i;
  switch (key_code)
    {
      /* Quit Application */
    case 'q':
    case 'Q':
      glFinish ();
      parameter[0]=3;
      exit (0);
      break;
    case 's':
    case 'S':
      halt = 2;
      parameter[0] = halt;
      break;
    case 'g':
    case 'G':
      halt = 1;
      parameter[0] = halt;
      break;
    }
};
/*------------------------------------------*/
void
idle (void)
{
  int i;
  int r;
  static float count = 0;
  /* Update  state variables */
  /* Update main and sub window */
  glutSetWindow (mainWindowID);
  glutPostRedisplay ();
  if (window2)
    {
      glutSetWindow (mainWindowID2);
      glutPostRedisplay ();
    }
   if (window3)
    {
      glutSetWindow (mainWindowID3);
      glutPostRedisplay ();
    }

  glutSetWindow (subWindowID);
  glutPostRedisplay ();
  tsim = input[9];
  tsimalt = tsim;
  pump_dp = input[21];
  pump_mp = input[22];
};
/***********************************************************************************/
void
submenu (int value)
{
  switch (value)
    {
    case 1:
      printf ("get the pump\n");
      if (window2)
	{
	  window2 = 0;
	  glutDestroyWindow (mainWindowID2);
	  glutChangeToMenuEntry (1, "display Pump", 1);
	}
      else
	{
	  glutInitWindowPosition (200, 200);
	  glutInitWindowSize (300, 200);
	  mainWindowID2 = glutCreateWindow ("Pump");
	  init_koord_pump ();
	  glutDisplayFunc (display2);
	  glutReshapeFunc (reshape2);
	  window2 = 1;
	  glutChangeToMenuEntry (1, "no display Pump", 1);
	}
      break;
    case 2:
       printf("draw\n");
       if (window3)
                 {
          window3 = 0;
          glutDestroyWindow (mainWindowID3);
          glutChangeToMenuEntry (1, "draw lines", 1);
        }
      else
        {
          glutInitWindowPosition (200, 200);
          glutInitWindowSize (300, 200);
          mainWindowID3 = glutCreateWindow ("Draw");
          glutDisplayFunc (display3);
          glutReshapeFunc (reshape3);
          window3 = 1;
          glutChangeToMenuEntry (1, "quit draw lines", 1);
        }
      break; 


    }
}
/*------------------------------------------*/
void
mainMenu (int value)
{
  static int is_translation = 0;
  static int dummy2 = 1;
  switch (value)
    {
    case 1:
      glutChangeToMenuEntry (3, "Wake Up", 3);
      halt = 2;
      parameter[0] = halt;
      break;
    case 2:
      ps_out = 1;
      printf("ps_out=1\n");
      break;
    case 3:
      printf ("WakeUP halt=%d\n", halt);
      if (halt && halt != 2)
	{
	  halt = 0;
	  glutChangeToMenuEntry (3, "Wake Up", 3);
	}
      else
	{
	  halt = 1;
	  glutChangeToMenuEntry (3, "Sleep", 3);
	};

      parameter[0] = halt;
      printf ("WakeUP halt=%d\n", halt);
      break;
    case 4:
      zoom_mode=0;
      ox1 = -1.2;
      ox2 = 1.2;
      oy1 = -1.2;
      oy2 = 1.6;
      reshape (W, H);
/*gluOrtho2D (ox1,ox2 , oy1, oy2);
*/
      break;
    case 5:
      glFinish ();
      parameter[0]=3;
      exit (0);
      break;
    }				/*case */
}
/*------------------------------------------*/
void
dummy (int value)
{
};
/*------------------------------------------*/
void
timerfunc (int t)
{
  int r, i;
/*glutTimerFunc(1,timerfunc,12);*/
}
/*------------------------------------------*/
/*******************************************************************************\
 *
 *      M A I N     F U N C T I O N 
 *
\*******************************************************************************/
int
main (int argc, char **argv)
{
/*shared init*/
  int i;
  int shidparam, shidfdata;
  int mmax = 0;
  key_t keyparam, keydata, keyfloat;
  float *shmdata;
  float *shmfdata;
  int shiddata;
  int *shmparam;
  float tics;
  char label[100];
  void init_koord ();
  void init_color ();
  void subDisplay ();
  void display ();
  void display2 ();

  zoom_mode=0;
  fence = 0;
  mousemotion = 0;
  xl = 0.0, xr = 0.0, yo = 0.0, yu = 0;
  halt = 1;
  ps_out = 0;
  d3flag = 2;
  W = WIDTH;
  H = HEIGHT;
  ox1 = -1.2;
  ox2 = 1.2;
  oy1 = -1.2;
  oy2 = 1.6;
  scalex = .3;
  scaley = .3;
  tsimalt = 0.0;

  init_color ();


  keyparam = 140;
  keydata = 141;
  keyfloat = 144;

/*-------*/

  if ((shidparam =
       shmget (keyparam, sizeof (int) * 100,
	       IPC_CREAT | 0666 /*zugriffsrechte */ )) < 0)
    {
      perror ("shmget");
      exit (1);
    }

  if ((shiddata =
       shmget (keydata, sizeof (float) * 60,
	       IPC_CREAT | 0666 /*zugriffsrechte */ )) < 0)
    {
      perror ("shmget shared data");
      exit (1);
    }


/*--------*/
  if ((shmparam = shmat (shidparam, NULL, 0)) == (int *) -1)
    {
      perror ("shmat param");
      exit (1);
    }
  if ((shmdata = shmat (shiddata, NULL, 0)) == (float *) -1)
    {
      perror ("shmat data");
      exit (1);
    }
/*-------------*/
  input = malloc_1float (60);
  input = shmdata;
  parameter = malloc_1int (100);
  parameter = shmparam;
  ndata = parameter[1];
  ndata2= parameter[7];
  nN = parameter[2];
/* fdata fdata*/
  if ((shidfdata =
       shmget (keyfloat, sizeof (float) * ((ndata+ndata2) * nN + 10),
	       IPC_CREAT | 0444 /*zugriffsrechte */ )) < 0)
    {
      perror ("shmget fdata");
      exit (1);
    }
  if ((shmfdata = shmat (shidfdata, NULL, 0)) == (float *) -1)
    {
      perror ("shmat data");
      exit (1);
    }
  fdata = shmfdata;

/* */


if (0) 
  printf ("input:%d nN=%2d par %d %d \n", parameter[1], nN, parameter[3],
	  parameter[4]);

  if (0)
    for (i = 0; i <= 200; i++)
      printf ("i: %2d adresse von shmparam %d  [0] %1.5e \n", i, &shmparam,
	      shmdata[i]);

  shared_data = malloc_2float (20, nN + 2);


 for (i=0;i<ndata;i++) { 
  shared_data[i] = fdata + (i*nN);
                       }
 for (i=3;i<ndata2+3;i++) {
  shared_data[i] = fdata + (i*nN);
                       }
  /* Glut initializations */
  glutInit (&argc, argv);
  glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowPosition (5, 5);
  glutInitWindowSize (WIDTH, HEIGHT);

  /* init(); */
  /* Main window creation and setup */
  mainWindowID = glutCreateWindow (TITLE);
  if (0) printf ("mainWindowID %d\n", mainWindowID);
  init ();
  glutMouseFunc (mouse);
  glutDisplayFunc (display);
  glutReshapeFunc (reshape);
  glutKeyboardFunc (keyboard);
  glutMotionFunc (motion);
  glutTimerFunc (1, timerfunc, 11);

  glutIdleFunc (idle);

  /* Create main menu */

  menIdMain = glutCreateMenu (mainMenu);
  glutAddMenuEntry ("Step", 1);
  glutAddMenuEntry ("Ps_out", 2);
  glutAddMenuEntry ("Sleep", 3);
  glutAddMenuEntry ("Zoom out", 4);
  glutAddMenuEntry ("Quit", 5);
  glutAttachMenu (GLUT_RIGHT_BUTTON);

  /* Create call list elements  */
  if (0) printf ("param %d %d \n", parameter[3], parameter[4]);
  init_koord ();


  subWindowID =
    glutCreateSubWindow (mainWindowID, 5, 5, WIDTH - 10, HEIGHT / 10);
  glutDisplayFunc (subDisplay);
  glutReshapeFunc (subReshape);
  menIdSubMain = glutCreateMenu (submenu);
  glutAddMenuEntry ("display pump", 1);
  glutAddMenuEntry ("drawlines", 2);
  glutAttachMenu (GLUT_RIGHT_BUTTON);
/*-----------------*/
  glutMainLoop ();

  return 0;
};
