#./etc/ShowLoadProfile.gnu
#headline:TIME[hhmmss] mp[kg/h] T_WW[C] P_WW[W] Q_WW[kWh]
#gnuplot <etc/ShowLoadProfile.gnu >ShowLoadProfile.ps
set term postscript color solid
set timefmt "%H%M%S"
set xdata time
set format x "%H:%M"
#
set title "load-profile WW loadWW.dat"
set xlabel 'time [hh:mm]'
set ylabel 'Temp[C]/Energy [kWh]'
set y2label 'Power[kW]/Massflow[kg/h] '
set grid
set xtics  #  grid
set y2tics    # 1h grid
set ytics 
set tics out
set key below
y1_max=90
y2_max=450
set xrange [0:]
set yrange [0:y1_max]
set y2range [0:y2_max]
#
plot "loadWW.dat" us 1:3 axes x1y1 ti 'y1:T_WW', \
'' us 1:($2) axes x1y2 ti 'y2:massflow mp [kg/h]' wi steps ,\
'' us 1:4 axes x1y1 ti 'y1:P_WW:kW' wi steps,'' us 1:($5*10) axes x1y1 ti 'y1:10*Q_WW:kWh' wi steps


