# awk -f xfig.hidden.awk <$HOME/.xfig                     
#
# sorting INFO entries in a xfig object and switching to hidden mode
# BEGIN section: initialize INFO arrays with END_LABEL patterns
# MAIN section : wait for info block, get koordinates
#                find INFO patterns and copy comment entries to INFO array
#                
# END section  : first try to fill INFO arrays with INFO_MAX infos extracted
#                from source code (sed in the heading of this awk-script)
#            
#                for i =1 to NR, run j from 1 to INFO_MAX  and search current
#                line in the INFO array
#                if line entry found, substitude this line with current info
#                entry (PAR1..11,INF1..8,OUT1..3,DERIV1..8
#
BEGIN { #---------------------------------------------------------------------
a=0;  # chriwi's debug flag ...
xxx=0; # dummy for sed-routine

PAR_MAX=xxx;  # try to substitude thisone 
INP_MAX=xxx;
OUT_MAX=xxx;
DERIV_MAX=xxx;

INFO_MAX=70;

END_LABEL=99999;
NF_MAX=40;
i_line=0;
hidden_flag=1;
FS=" ";
StrEnd="\0"

if (PAR_MAX==0)     PAR_MAX =INFO_MAX;
if (INP_MAX==0)     INP_MAX =INP_MAX;
if (OUT_MAX==0)     OUT_MAX =OUT_MAX;
if (DERIV_MAX==0) DERIV_MAX =DERIV_MAX;

# initialize TYPE infos
TYPE_LINE[1]=TYPE_LINE[2]=END_LABEL;
if (hidden_flag) TYPE_BEGIN[1]="4 0 7 50 0 0 11 0.0000 12 135 1125";
else             TYPE_BEGIN[1]="4 0 7 50 0 0 11 0.0000 4 135 1125";
TYPE_X_POS[i]=END_LABEL;
TYPE_Y_POS[i]=END_LABEL;

# initialize PAR array
for (i=1;i<=INFO_MAX+1;i++) {
    # 4 0 7 50 0 0 11 0.0000 4 135 1125 7015 6240 PAR9: 90 [] slope \001
  PAR_LINE[i]=END_LABEL;
  if (hidden_flag) PAR_BEGIN[i]="4 0 7 50 0 0 11 0.0000 12 135 1125";
  else             PAR_BEGIN[i]="4 0 7 50 0 0 11 0.0000 4 135 1125";
  PAR_X_POS[i]=END_LABEL;
  PAR_Y_POS[i]=END_LABEL;
  }
# initialize INP array
for (i=1;i<=INFO_MAX+1;i++) {
    # 4 0 7 50 0 0 11 0.0000 4 135 1125 7015 6240 PAR9: 90 [] slope \001
  INP_LINE[i]=END_LABEL;
  if (hidden_flag) INP_BEGIN[i]="4 0 7 50 0 0 11 0.0000 12 135 1125";
  else             INP_BEGIN[i]="4 0 7 50 0 0 11 0.0000 4 135 1125";
  INP_X_POS[i]=END_LABEL;
  INP_Y_POS[i]=END_LABEL;
  }
# initialize OUT array
for (i=1;i<=INFO_MAX+1;i++) {
    # 4 0 7 50 0 0 11 0.0000 4 135 1125 7015 6240 PAR9: 90 [] slope \001
  OUT_LINE[i]=END_LABEL;
  if (hidden_flag) OUT_BEGIN[i]="4 0 7 50 0 0 11 0.0000 12 135 1125";
  else             OUT_BEGIN[i]="4 0 7 50 0 0 11 0.0000 4 135 1125";
  OUT_X_POS[i]=END_LABEL;
  OUT_Y_POS[i]=END_LABEL;
  }
# initialize DERIV array
for (i=1;i<=INFO_MAX+1;i++) {
    # 4 0 7 50 0 0 11 0.0000 4 135 1125 7015 6240 PAR9: 90 [] slope \001
  DERIV_LINE[i]=END_LABEL;
  if (hidden_flag) DERIV_BEGIN[i]="4 0 7 50 0 0 11 0.0000 12 135 1125";
  else             DERIV_BEGIN[i]="4 0 7 50 0 0 11 0.0000 4 135 1125";
  DERIV_X_POS[i]=END_LABEL;
  DERIV_Y_POS[i]=END_LABEL;
  }
} # ---------------------------------------------------------------------------
#
# ---------------------------------------------MAIN------------------------------
{
Line[NR]="";
for ( i=1; i<=NF; i+=1 ) { if (i==1) Line[NR]=$i            # NF number of fields
                           else      Line[NR]=Line[NR]" "$i # NF number of fields
                         }
i_line+=1
# ------------------------------------------------------------------------------
for(i=1; i<=NF; i+=1)  # find info block , get position
 {
 if ( ($1=="6") && (first_time_flag==0) ) 
  {
  first_time_flag=1;
  x1_unit=$2; y1_unit=$3; x2_unit=$4; y2_unit=$5;
  if (a) printf("!!!!!!x1:%s y1:%s x2:%s y2:%s !!!!!!!!!",$2,$3,$4,$5);
  }
 if ($1=="6") # get x,y koordinates of info-compound, !! valid during info block reading!!
  {
  x1_info_tmp=$2; y1_info_tmp=$3; x2_info_tmp=$4; y2_info_tmp=$5;
  Info_Block_line=i;  #later modify coordinates (if hidden)
  #  printf("!!!!!!x1:%s y1:%s x2:%s y2:%s !!!!!!!!!",$2,$3,$4,$5);
  }

if (a) { printf("%s",$i)
  if (i==NF) printf(" ");
  else       printf(" ");
  }
 } 
# ------------------------------------------------------------------------------
#
if (substr($14,1,3)=="TYP")  #------------------TYPE -------------------
  {
  TYPE_LINE[1]=i_line; # store line number
  # x-pos:$12; y_pos:$13;
  for (k=14;k<=NF;k++) TYPE_END[1]=TYPE_END[1]" "$k #get reset line
  if (a) printf("... type found ... ");
  }
if (substr($14,1,3)=="PAR")  #-------------------PAR--------------------
  {
  if (substr($14,5,1)==":") par_nr=substr($14,4,1);
  else                      par_nr=substr($14,4,2);
  x1_info=x1_info_tmp; y1_info=y1_info_tmp; x2_info=x2_info_tmp; y2_info=y2_info_tmp;

  PAR_LINE[par_nr]=i_line; # store line number
  # x-pos:$12; y_pos:$13;
  for (k=14;k<=NF;k++) PAR_END[par_nr]=PAR_END[par_nr]" "$k #get reset line
  if (a) printf("... par %d found ... ",par_nr);
  }
if ( ($1=="4") && (substr($14,1,3)=="INP") ) #--------------------INP-------------------
  {
  if (substr($14,5,1)==":") inp_nr=substr($14,4,1);
  else                      inp_nr=substr($14,4,2);
  INP_LINE[inp_nr]=i_line; # store line number
  # x-pos:$12; y_pos:$13;
  for (k=14;k<=NF;k++) INP_END[inp_nr]=INP_END[inp_nr]" "$k #get reset line
  if (a) printf("... inp %d found ,line:%d... ",inp_nr,INP_LINE[inp_nr]);
  }
if ( ($1=="4") && (substr($14,1,3)=="OUT") ) #--------------------OUT-------------------
  {
  if (substr($14,5,1)==":") out_nr=substr($14,4,1);
  else                      out_nr=substr($14,4,2);
  OUT_LINE[out_nr]=i_line; # store line number
  # x-pos:$12; y_pos:$13;
  for (k=14;k<=NF;k++) OUT_END[out_nr]=OUT_END[out_nr]" "$k; #get reset line
  if (a) printf("... out %d found ... ",out_nr);
  };
if ( ($1=="4") && (substr($14,1,5)=="DERIV") ) #-------------------DERIV----------------
  {
  if (substr($14,7,1)==":") deriv_nr=substr($14,6,1);
  else                      deriv_nr=substr($14,6,2);
  #
  DERIV_LINE[deriv_nr]=i_line; # store line number
  # x-pos:$12; y_pos:$13;
  for (k=14;k<=NF;k++) DERIV_END[deriv_nr]=DERIV_END[deriv_nr]" "$k #get reset line
  if (a) printf("... deriv %d found ... %d ",deriv_nr,i_line);
  };
 if (a) printf("\n");
} #------------------------------------------------------------------------------------
#
#
#
#
#
#
#
END {
#-----------------------------FILL INFO ARRAYS-------------------------------------
j=PAR_MAX;   # 
while (j>0) {
if (PAR_LINE[j]==END_LABEL) { # INP_MAX is not set in .xfig
  PAR_LINE [j]= PAR_LINE[1];  # but INP1 should be set 
  PAR_BEGIN[j]=PAR_BEGIN[1];
  PAR_X_POS[j]=PAR_X_POS[1];
  PAR_Y_POS[j]=PAR_Y_POS[1];
  PAR_END  [j]=sprintf(" PAR%s: [] dummy \\001",j);
  }
if ( (PAR_LINE[j-1]==END_LABEL) && (PAR_LINE[j]!=END_LABEL) ) { #substitude thisone
  PAR_LINE [j-1]= PAR_LINE[j];
  PAR_BEGIN[j-1]=PAR_BEGIN[j];
  PAR_X_POS[j-1]=PAR_X_POS[j];
  PAR_Y_POS[j-1]=PAR_Y_POS[j];
  PAR_END  [j-1]=sprintf(" PAR%s: [] dummy \\001",j-1);
  }
if (a) printf("PAR_LINE[%d]:%d %s %d %d %s\n",j,PAR_LINE[j], \
         PAR_BEGIN[j],PAR_X_POS[j],PAR_Y_POS[j],PAR_END  [j]);
j--;
}

j=INP_MAX;   # 
while (j>0) {
if (INP_LINE[j]==END_LABEL) { # INP_MAX is not set in .xfig
  INP_LINE [j]= INP_LINE[1];  # but INP1 should be set 
  INP_BEGIN[j]=INP_BEGIN[1];
  INP_X_POS[j]=INP_X_POS[1];
  INP_Y_POS[j]=INP_Y_POS[1];
  INP_END  [j]=sprintf(" INP%s: [] dummy \\001",j);
  }
if ( (INP_LINE[j-1]==END_LABEL) && (INP_LINE[j]!=END_LABEL) ) { #substitude thisone
  INP_LINE [j-1]= INP_LINE[j];
  INP_BEGIN[j-1]=INP_BEGIN[j];
  INP_X_POS[j-1]=INP_X_POS[j];
  INP_Y_POS[j-1]=INP_Y_POS[j];
  INP_END  [j-1]=sprintf(" INP%s: [] dummy \\001",j-1);
  }
if (a) printf("INP_LINE[%d]:%d %s %d %d %s\n",j,INP_LINE[j], \
         INP_BEGIN[j],INP_X_POS[j],INP_Y_POS[j],INP_END  [j]);
j--;
}

j=OUT_MAX;   # 
while (j>0) {
if (OUT_LINE[j]==END_LABEL) { # OUT_MAX is not set in .xfig
  OUT_LINE [j]= OUT_LINE[1];  # but OUT1 should be set 
  OUT_BEGIN[j]=OUT_BEGIN[1];
  OUT_X_POS[j]=OUT_X_POS[1];
  OUT_Y_POS[j]=OUT_Y_POS[1];
  OUT_END  [j]=sprintf(" OUT%s: [] dummy \\001",j);
  }
if ( (OUT_LINE[j-1]==END_LABEL) && (OUT_LINE[j]!=END_LABEL) ) { #substitude thisone
  OUT_LINE [j-1]= OUT_LINE[j];
  OUT_BEGIN[j-1]=OUT_BEGIN[j];
  OUT_X_POS[j-1]=OUT_X_POS[j];
  OUT_Y_POS[j-1]=OUT_Y_POS[j];
  OUT_END  [j-1]=sprintf(" OUT%s: [] dummy \\001",j-1);
  }
if (a) printf("OUT_LINE[%d]:%d %s %d %d %s\n",j,OUT_LINE[j], \
         OUT_BEGIN[j],OUT_X_POS[j],OUT_Y_POS[j],OUT_END  [j]);
j--;
}

j=DERIV_MAX;   # 
while (j>0) {
if (DERIV_LINE[j]==END_LABEL) { # DERIV_MAX is not set in .xfig
  DERIV_LINE [j]= DERIV_LINE[1];  # but DERIV1 should be set 
  DERIV_BEGIN[j]=DERIV_BEGIN[1];
  DERIV_X_POS[j]=DERIV_X_POS[1];
  DERIV_Y_POS[j]=DERIV_Y_POS[1];
  DERIV_END  [j]=sprintf(" DERIV%s: [] dummy \\001",j);
  }
if ( (DERIV_LINE[j-1]==END_LABEL) && (DERIV_LINE[j]!=END_LABEL) ) { #substitude thisone
  DERIV_LINE [j-1]= DERIV_LINE[j];
  DERIV_BEGIN[j-1]=DERIV_BEGIN[j];
  DERIV_X_POS[j-1]=DERIV_X_POS[j];
  DERIV_Y_POS[j-1]=DERIV_Y_POS[j];
  DERIV_END  [j-1]=sprintf(" DERIV%s: [] dummy \\001",j-1);
  }
if (a) printf("DERIV_LINE[%d]:%d %s %d %d %s\n",j,DERIV_LINE[j], \
         DERIV_BEGIN[j],DERIV_X_POS[j],DERIV_Y_POS[j],DERIV_END  [j]);
j--;
}


#---------------------------------------------------SORTING------------------------------
current_par=1; # sort parameters
current_inp=1;
current_out=1;
current_deriv=1;
current_type=1;
info_nr=0;
for (i=1;i<=i_line;i++) {
 found=0;
 first_time_flag=1;
 j=1; # --------------------------walk through par entries and check------------------- 
 while ( !(   (  PAR_LINE[j]==END_LABEL) \
           && (  INP_LINE[j]==END_LABEL) \
           && (  OUT_LINE[j]==END_LABEL) \
           && (DERIV_LINE[j]==END_LABEL) \
       ) )
       {     # is there an info line ?
       #
       if (a) printf("line:%d j:%d PAR_LINE:%d INP_LINE:%d OUT_LINE:%d DERIV_LINE:%d found:%d\n", \
                      i,j,PAR_LINE[j],INP_LINE[j],OUT_LINE[j],DERIV_LINE[j],found)
       #
       if ( (     (TYPE_LINE[j]==i) \
              ||   (PAR_LINE[j]==i) \
              ||   (INP_LINE[j]==i) \
              ||   (OUT_LINE[j]==i) \
              || (DERIV_LINE[j]==i) )  \
           && (found==0) )
         { 
         if (a) printf("info found: j:%d ",j);
         info_nr+=1; # number if info entry
         #-------------------------------- search in TYPE array ------------
         if ( (TYPE_LINE[current_type]!=END_LABEL) && (found==0) ) {
             if (a) printf("type_line:%d :",TYPE_LINE[1]);
             TYPE_X_POS[1]=x1_info;
             if (hidden_flag) TYPE_Y_POS[1]=y1_info+30;
             else             TYPE_Y_POS[1]=y1_info+30+info_nr*140;
             printf("%s %d %d %s\n", \
             TYPE_BEGIN[1],TYPE_X_POS[1] \
               ,TYPE_Y_POS[1],TYPE_END[1]);
             current_type+=1;
             found=1;
             }
         #-------------------------------- search in PAR array--------------
         if ( (PAR_LINE[current_par]!=END_LABEL) && (found==0) ) {
             if (a) printf("par_line:%d :",PAR_LINE[current_par]);
             PAR_X_POS[current_par]=x1_info;
             if (hidden_flag) PAR_Y_POS[current_par]=y1_info+30;
             else             PAR_Y_POS[current_par]=y1_info+30+info_nr*140;
#             printf("%s %d %d %s\n", \
             dummy_string=sprintf("%s %d %d %s\n", \
              PAR_BEGIN[current_par],PAR_X_POS[current_par] \
              ,PAR_Y_POS[current_par],PAR_END[current_par]);
             for (i5=1;i5<=length(dummy_string);i5++) {
               if ( (substr(dummy_string,i5,1)==" ") && ( substr(dummy_string,i5-1,1)==" ") ) { 
                    printf(""); }
               else printf("%c",substr(dummy_string,i5,1) );
             }
             current_par+=1;
             #while (PAR_LINE[current_par]==PAR_LINE[current_par-1]) # add spaces
             while (current_par<=PAR_MAX)
              {
              info_nr+=1; # number if info entry
              PAR_X_POS[current_par]=x1_info;
              if (hidden_flag) PAR_Y_POS[current_par]=y1_info+30;
              else             PAR_Y_POS[current_par]=y1_info+30+info_nr*140;
              printf("%s %d %d %s\n", \
                PAR_BEGIN[current_par],PAR_X_POS[current_par] \
               ,PAR_Y_POS[current_par],PAR_END[current_par]);
              current_par+=1;
              }
             found=1;
             }
         #-------------------------------- search in INP array---------------
         if ( (INP_LINE[current_inp]!=END_LABEL) && (found==0) ) {
             if (a) printf("inp_line:%d :",INP_LINE[current_inp]);
             INP_X_POS[current_inp]=x1_info;
             if (hidden_flag) INP_Y_POS[current_inp]=y1_info+30;
             else             INP_Y_POS[current_inp]=y1_info+30+info_nr*140;
#             printf("%s %d %d %s\n", \
             dummy_string=sprintf("%s %d %d %s\n", \
             INP_BEGIN[current_inp],INP_X_POS[current_inp] \
               ,INP_Y_POS[current_inp],INP_END[current_inp]);
             for (i5=1;i5<=length(dummy_string);i5++) {
               if ( (substr(dummy_string,i5,1)==" ") && ( substr(dummy_string,i5-1,1)==" ") ) { 
                    printf(""); }
               else printf("%c",substr(dummy_string,i5,1) );
             }
             current_inp+=1;
             #while (INP_LINE[current_inp]==INP_LINE[current_inp-1]) # add spaces
             while (current_inp<=INP_MAX)
              {
              info_nr+=1; # number if info entry
              INP_X_POS[current_inp]=x1_info;
              if (hidden_flag) INP_Y_POS[current_inp]=y1_info+30;
              else             INP_Y_POS[current_inp]=y1_info+30+info_nr*140;
              printf("%s %d %d %s\n", \
                INP_BEGIN[current_inp],INP_X_POS[current_inp] \
               ,INP_Y_POS[current_inp],INP_END[current_inp]);
              current_inp+=1;
              }
             found=1;
             }
         #-------------------------------- search in OUT array-----------------
         if ( (OUT_LINE[current_out]!=END_LABEL) && (found==0) ) {
             if (a) printf("out_line:%d :",OUT_LINE[current_out]);
             OUT_X_POS[current_out]=x1_info;
             if (hidden_flag) OUT_Y_POS[current_out]=y1_info+30;
             else             OUT_Y_POS[current_out]=y1_info+30+info_nr*140;
#             printf("%s %d %d %s\n", \
#             OUT_BEGIN[current_out],OUT_X_POS[current_out] \
#               ,OUT_Y_POS[current_out],OUT_END[current_out]);
             dummy_string=sprintf("%s %d %d %s\n", \
               OUT_BEGIN[current_out],OUT_X_POS[current_out] \
               ,OUT_Y_POS[current_out],OUT_END[current_out]);
             for (i5=1;i5<=length(dummy_string);i5++) {
               if ( (substr(dummy_string,i5,1)==" ") && ( substr(dummy_string,i5-1,1)==" ") ) { 
                    printf(""); }
               else printf("%c",substr(dummy_string,i5,1) );
             }
             current_out+=1;
             #while (OUT_LINE[current_out]==OUT_LINE[current_out-1]) # add spaces
             while (current_out<=OUT_MAX) # add all dummies 
              {
              info_nr+=1; # number if info entry
              OUT_X_POS[current_out]=x1_info;
              if (hidden_flag) OUT_Y_POS[current_out]=y1_info+30;
              else             OUT_Y_POS[current_out]=y1_info+30+info_nr*140;
              printf("%s %d %d %s\n", \
                OUT_BEGIN[current_out],OUT_X_POS[current_out] \
               ,OUT_Y_POS[current_out],OUT_END[current_out]);
              current_out+=1;
              }
             found=1;
             }
         #-------------------------------- search in DERIV array----------------
         if ( (DERIV_LINE[current_deriv]!=END_LABEL) && (found==0) ) {
             if (a) printf("deriv_line:%d :",DERIV_LINE[current_deriv]);
             DERIV_X_POS[current_deriv]=x1_info;
             if (hidden_flag) DERIV_Y_POS[current_deriv]=y1_info+30;
             else             DERIV_Y_POS[current_deriv]=y1_info+30+info_nr*140;
             printf("%s %d %d %s\n", \
             DERIV_BEGIN[current_deriv],DERIV_X_POS[current_deriv] \
              ,DERIV_Y_POS[current_deriv],DERIV_END[current_deriv]);
             current_deriv+=1;
             #while (DERIV_LINE[current_deriv]==DERIV_LINE[current_deriv-1]) # add spaces
             while (current_deriv<=DERIV_MAX)
              {
              info_nr+=1; # number if info entry
              DERIV_X_POS[current_deriv]=x1_info;
              if (hidden_flag) DERIV_Y_POS[current_deriv]=y1_info+30;
              else             DERIV_Y_POS[current_deriv]=y1_info+30+info_nr*140;
              printf("%s %d %d %s\n", \
                DERIV_BEGIN[current_deriv],DERIV_X_POS[current_deriv] \
               ,DERIV_Y_POS[current_deriv],DERIV_END[current_deriv]);
              current_deriv+=1;
              }
             found=1;
             }
         } # end if info line found
       else { if (a) printf("j=%d, no info-line found:%d  \n",j,found); }
       j+=1;                                       
       if (j>INFO_MAX+1) {printf("INFO_FIELD > INFO_MAX=%d !!!! .............\n",j,INFO_MAX); 
                       exit(-1); 
                      };
       } # end while walk throu info arrays with j
       # if ( (found==1) && (a==1) ) printf("line:%d j=%d: \n",i,j);
       if ( (a) && (first_time_flag==1) && (found==0) ) {
             printf("not this:i:%d: inp_line[2]:%d %s\n",i,INP_LINE[2],Line[i]);
             
             }
       for (j=1;j<=INFO_MAX;j++) {
        if ( (TYPE_LINE[j]==i) || (PAR_LINE[j]==i) || (INP_LINE[j]==i) \
            ||(OUT_LINE[j]==i)||(DERIV_LINE[j]==i) ) found=1;
        }
       if ( (found==0) && (first_time_flag==1) ) {
           printf("%s\n",Line[i]);
           first_time_flag=0;
           }
#
} # walk through all lines 
#
#
#
if (a) printf("\n\n");
j=1; # --------------------------check info arrays ------------------------------------
while (PAR_LINE[j]!=END_LABEL)
{
if (a) printf("par_line:%d :%s %d %d %s\n", \
    PAR_LINE[j],PAR_BEGIN[j],PAR_X_POS[j],PAR_Y_POS[j],PAR_END[j]);
j+=1;
}
if (a) print
j=1;
while (OUT_LINE[j]!=END_LABEL)
{
if (a) printf("out_line:%d :%s %d %d %s\n", \
    OUT_LINE[j],OUT_BEGIN[j],OUT_X_POS[j],OUT_Y_POS[j],OUT_END[j]);
j+=1;
}
if (a) print
j=1;
while (DERIV_LINE[j]!=END_LABEL)
{
if (a) printf("deriv_line:%d :%s %d %d %s\n", \
    DERIV_LINE[j],DERIV_BEGIN[j],DERIV_X_POS[j],DERIV_Y_POS[j],DERIV_END[j]);
j+=1;
}



#4 0 7 50 0 0 11 0.0000 13 135 2130 7020 6798 PAR2: 0.93 [W/mK] lambda layer \001
#4 0 7 50 0 0 11 0.0000 4 135 1125 7020 6798  PAR2: 0.93 [W/mK] lambda layer \001
#4 0 7 50 0 0 11 0.0000 4 135 1125  PAR2: 0.93 [W/mK] lambda layer \001
}
