#include "global.h" 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
000815 error message PAR_MAX updated
001109 char* out_label[unit][INPUT_MAX] included for printer headline
*/

/*-----------------------------------DEK_READER-----------------*/

int dek_reader(int *type,double **par,int **in_u,int **in_nr,
               double **out_n,double **out_o,
               double **deriv_o,double **deriv_n,char ***out_label)
{
const int a=0; /*-----------------ANALYSE-PRINTS with a=1!!!!!*/
FILE *position;
char Zeile[201],*rest,string1[80],string2[80],string3[80],string4[80];
/* char out_label[400][30][30]; */

int k_unit;  /* unit counter in dek */
int unit_nr,type_nr,par_nr,input_nr,deriv_nr,k;

if ((position=fopen("sim.dek","r"))==NULL)
   { printf("no 'sim.dek' !! \n\n");return -1; }
   
for (k_unit=1;k_unit<=UNIT_MAX;k_unit++) /*--exit on END-----*/
  {
  /*--------------------------UNIT_READ--------------------------*/

    /*--------------- Solange string1 != "UNIT" && != "END"*/
    while ( (strstr(string1,"UNIT")==NULL) &&
            (strstr(string1,"END")==NULL) )   /* check pattern in string*/
      {
        /*printf("Zeile[0]:%c\n",Zeile[0]);*/
        if (fgets(Zeile,200,position)==NULL)   /* read line */
          {
            printf("END of FILE when searching 'UNIT' String= %s \n",
                    Zeile);
            string1[1]='E';
            string1[2]='N';
            string1[3]='D';
            break;
          };

                                      /* read string1 in line (stop at SPACE)*/
        sscanf(Zeile,"%s",string1);
      };

    if (strstr(string1,"END")!=NULL) break; /* exit on END----*/

    if (a) printf("pattern-string1=%s \n",string1);

     /* read UNIT-No and TYPE-No */
    sscanf(Zeile,"%s %d %s %d",string1,&unit_nr,string2,&type_nr);

    if ( (unit_nr>=UNIT_MAX) || (unit_nr<0) )
      { printf("dek_reader: UNIT_MAX:%d unit_nr:%d\n",UNIT_MAX,unit_nr);exit (-1); }

    if (strstr(string1,"TYPE")!=NULL)               /*(string1 != "TYPE")*/
      {  printf(" error reading Fehler TYPE string \n"); };
      /* unit_nr is actually nr of  dek , not k_unit!!!*/
    type[unit_nr]=type_nr;

    if (unit_nr!=k_unit) printf("UNIT order with gaps: UNIT %d\n",
                                unit_nr);
    if (a) printf("  UNIT %d is TYPE %d \n",unit_nr,type_nr);

    /*------------------------------PARAMETER_READ-----------------*/
    if (fgets(Zeile,200,position)==NULL)
      {
        printf("line read exit at PARAMETER search  %s \n",Zeile);
        /* exit (-1); */
      };
    sscanf(Zeile,"%s",string1);
    if (a) printf("pattern-string1=%s \n",string1);

    while ( (strstr(string1,"PARAMS")==NULL) )  /*run to "PARAMS" */
      {
        if (fgets(Zeile,200,position)==NULL) break ;
        sscanf(Zeile,"%s",string1);
      };
     /*read Par_Nr,Pars*/
    sscanf(Zeile,"%s %d",string1,&par_nr);
     /*alle Parameter einlesen*/
    if ( (par_nr>=PAR_MAX) || (par_nr<0) )
      { printf("dek_reader: unit[%d]:number of parameters:%d >PAR_MAX:%d\n"
               ,unit_nr,par_nr,PAR_MAX);exit (-1); }
    k=1;
    while (k<=par_nr)
      {
        if (fgets(Zeile,200,position)==NULL)
          {
            printf(" exit line read %s (!minimum 1 parameter!!) \n",Zeile);
          };
        sscanf(Zeile,"%s",string1);
        if (strstr(string1,"*")==NULL)
          {
            par[unit_nr][k]=strtod(string1,&rest);
            if (a) printf("Parameter(%d) von UNIT(%d) =%f aus string1=%s\n",
                           k,unit_nr,par[unit_nr][k],string1);
            k++;
          };
       }; /*end_while*/

  /*------------------------------INPUTS_READ-----------------------*/

    if (fgets(Zeile,200,position)==NULL)
      {
        printf(" EOF exit line read %s \n",Zeile);
        return (k_unit);
      };
    sscanf(Zeile,"%s",string1);

    /* lese, bis string1="INPUTS" || "UNIT"  */
    while ( (strstr(string1,"INPUTS")==NULL) &&
            (strstr(string1,"UNIT")==NULL) )
      {
        if (fgets(Zeile,200,position)==NULL)
          { printf(" EOF exit line read %s \n",Zeile);
            return (k_unit);
          };
        sscanf(Zeile,"%s",string1);
      };

    if (a) printf("pattern-string1=%s \n",string1);

    if (strstr(string1,"INPUTS")!=NULL) /*(string1 != "INPUTS"*/
      {                                       /*read inputs__Nr,Inputs*/
        sscanf(Zeile,"%s %d",string1,&input_nr);

        if ( (input_nr>INPUT_MAX) || (input_nr<0) )
          { printf("input_nr:%d in dek_reader unit:%d \n",input_nr,unit_nr);exit (-1); }

        k=1;                                     /*alle Inputs einlesen*/
        while (k<=input_nr)
          {
            /* search input_units, not empty lines */
            out_label[unit_nr][k][0]=string4[0]='\0';
            while (1)
             {
               if (fgets(Zeile,200,position)==NULL)
                 { printf(" EOF exit line read %s \n",Zeile);
                   return(k_unit);
                 };
               string4[0]='\0';
               sscanf(Zeile,"%s %s %s %s",string1,string2,string3,string4);
               if ( (( (int) strlen(Zeile)  )>2) &&
                    (strstr(string1,"*")==0) ) break;
             };

            /* out_label included */
            sprintf(out_label[unit_nr][k],"%s",string4);
            in_u[unit_nr][k]=(int) (strtod(string1,&rest));
            in_nr[unit_nr][k]=(int) (strtod(string2,&rest));
            if ( (strstr(string2,","))!=NULL)
              {
                printf("Komma vor out_nr bei UNIT %d !!!\n",unit_nr);
                exit (-1);
              };
            if (a) 
                printf("INPUT [%d][%d] from OUTPUT [%d][%d] ... strings %s %s\n",
	           unit_nr,k,in_u[unit_nr][k],in_nr[unit_nr][k],string1,string2);
            if (a) printf("out_label[%d][%d]:%s\n",unit_nr,k,
                   out_label[unit_nr][k]);

             k++;
          };
                  /*-----------read INPUT INITIAL VALUES ---------*/
        k=1;
        while (k<=input_nr)
          {
            /* search input_units, not empty lines */
            while (1)
             {
               if (fgets(Zeile,200,position)==NULL)
                 { printf(" EOF end of line return %s \n",Zeile);
                   return(k_unit);
                 };
               sscanf(Zeile,"%s %s",string1,string2);
               if ( (( (int) strlen(Zeile)  ) > 1 ) &&
                    (strstr(string1,"*")==0) ) break;
             };
            if (in_u[unit_nr][k]==0)  /*shift initials for fixed values */
              {
                out_o  [unit_nr][OUT_MAX0+k]
                 =out_n[unit_nr][OUT_MAX0+k]
		         =strtod(string1,&rest);
                in_u [unit_nr][k]=unit_nr;
                in_nr[unit_nr][k]=OUT_MAX0+k;
                if (a)
                printf("INPUT_INITIAL(%d) of UNIT(%d) =%f from string1=%s\n",
                    k+OUT_MAX0,unit_nr,out_o[unit_nr][OUT_MAX0+k],string1);
              }
            else
              {
		      /*shift initials for some TYPES */
              out_o  [unit_nr][k+OUT_MAX0]
		       =out_n[unit_nr][k+OUT_MAX0]=strtod(string1,&rest);
                /* reset outs */
		      out_o  [unit_nr][k]
		       =out_n[unit_nr][k]=0;

                if (a)
                printf("INPUT_INITIAL(%d) von UNIT(%d) =%f aus string1=%s\n",
                        k,unit_nr,out_o[unit_nr][k],string1);
              };
            k++;
          }; /*while-end*/


/*-------------------------READ DERIVATIVES---------------------*/
      /*search DERIVATIVES, if INPUTS != 0 */

     if (fgets(Zeile,200,position)==NULL)
      {
        printf(" EOF exit line read %s \n",Zeile);
        return(k_unit);
      };
    sscanf(Zeile,"%s",string1);

    /* lese, bis string1="DERIVATIVES" || "UNIT"  */
    while ( (strstr(string1,"DERIVATIVES")==NULL) &&
            (strstr(string1,"UNIT")==NULL) )
      {
        if (fgets(Zeile,200,position)==NULL)
          { printf(" EOF exit line read %s \n",Zeile);
            return(k_unit);
          };
        sscanf(Zeile,"%s",string1);
      };

    if (a) printf("pattern-string1=%s \n",string1);

    if (strstr(string1,"DERIVATIVES")!=NULL) /*(string1 != "DERIVATIVES"*/
      {                                       /*read deriv__Nr*/
        sscanf(Zeile,"%s %d",string1,&deriv_nr);

        if ( (deriv_nr>=DERIV_MAX) || (deriv_nr<0) )
          { printf("deriv_nr:%d in dek_reader unit:%d \n",deriv_nr,unit_nr);exit (-1); }

        k=1;                                     /*alle Derivs einlesen*/
        while (k<=deriv_nr)
          {
            /* search derivation-values, not empty lines and comments*/
            while (1)
             {
               if (fgets(Zeile,200,position)==NULL)
                 { printf(" EOF exit line read %s \n",Zeile);
                   return(k_unit);
                 };
               sscanf(Zeile,"%s %s",string1,string2);
               if ( (( (int) strlen(Zeile)  )>1) &&
                    (strstr(string1,"*")==0) ) break;
             };

            deriv_o[unit_nr][k]=(int) (strtod(string1,&rest));
            deriv_n[unit_nr][k]=(int) (strtod(string1,&rest));
            if ( (strstr(string2,","))!=NULL)
              {
                printf("',' at DERIVATIONS  UNIT %d !!!\n",unit_nr);
                exit (-1);
              };

            if (a) printf("DERIVATIVES_Nr(%d) of UNIT(%d) =%.3e from string1=%s\n",
                          k,unit_nr,deriv_o[unit_nr][k],string1);

             k++;
          };

       } /*if-end, if DERIVATIVES*/

        /*--------------------------------------end of deriv-search */

      } /*if-end,if "INPUTS" exists */

    else { if (a) printf("UNIT %d , no INPUTS no DERIVATIVES!!! \n",unit_nr); };


  } /*next_lauf_unit*/
fclose(position);
return (k_unit-1); /*retrun number of  units */
}

