/* gnu_plotter.c */
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/

/*
000830  bug fix scaling factor 2nd plot diagram i+OUT_MAX0+5-graphs0
001110 labels included with char***out_label
001213 export konti .xfig
010517 auto range update
010522 local_init_flag created
010710 fprintf(gnu1) subs with sprintf(s,) 
011119 gnuplot string: sprintf(s," ti \'scale:%. with simpe quotation
011210 comment labels
020404 max number of plots REPLOT_MAX  added 
020515 chriwi : break erased, write non connected inputs to plot.dat
020522 n_cycle defined
*/

#include <stdio.h>  /* there should be popen() */
#include <stdlib.h>
#include <string.h>

#include <unistd.h> /* there is sleep() in Linux */ 
#include "global.h" 

/*-------------------------------------------GNU_PLOTTER--------*/

int gnu_plotter(unit,par,in_u,in_nr,out_o,out_n,h,tsim,init_flag,
                stop_flag,unix_flag,day_of_year,out_label)
           int    unit;      /* current unit number */
           double **par;     /* parameter array par[unit][1..PARMAX]  */
           int    **in_u;    /* input unit array, input connections   */
           int    **in_nr;   /* input number array                    */
           double **out_o;   /* output array with privious state      */
           double **out_n;   /* output array with current state       */
           double h;         /* sim time step                         */
           double tsim;      /* simulation time in [s] of this day    */
           int    init_flag; /* set at initial loop of sim            */
           int    stop_flag; /* set at simulation end                 */
           int    unix_flag; /* running on unix/linux                 */
           int    day_of_year;
           char ***out_label;
{
/* 
   plot inp1 to inp5 in gnuplot-diagram0,inp6 to inp10 in diagram1

   TYPE 65
   PRIORITY  12         used by config routine
   HYDRAULIC 99         used by config routine


   PAR1: 24 [h] 'xmax' time_max
   PAR2: 60 [min] 'dt_update' refresh time [min] (<=time_max)
   PAR3: 0   [1] 'y_min0' plot0
   PAR4: 100 [1] 'y_max0' plot0 
   PAR5: 0   [1] 'y_min1' plot1
   PAR6: 100 [1] 'y_max1' plot1
   PAR7: 1 [1] 'online' 1: online-plot 0:no-plot 
   PAR8: 1 [1] 'autorange' 1: autorange 
   PAR9: 1 [1] 'wait' 1: file "no" is active; wait on 'n' 

   INP1: 1 [1] 'in1' diagram0, weighting factor
   INP2: 1 [1] 'in2' diagram0, weighting factor  
   INP3: 1 [1] 'in3' diagram0, weighting factor  
   INP4: 1 [1] 'in4' diagram0, weighting factor  
   INP5: 1 [1] 'in5' diagram0, weighting factor  
   INP6: 1 [1] 'in1' diagram1, weighting factor  
   INP7: 1 [1] 'in2' diagram1, weighting factor  
   INP8: 1 [1] 'in3' diagram1, weighting factor  
   INP9: 1 [1] 'in4' diagram1, weighting factor  
   INP10: 1 [1] 'in5' diagram1, weighting factor  

*/

int a=0; /*-----debug a=1!!!!!*/

#define REPLOT_MAX 30
#define MAX_POINTS 300        /* Max Number of values for t-Axes */

static FILE *gnu1,*gnu2;
FILE *gnudata;  /* GNU-Plotraw-data */
FILE *no; /* ask for continue in File 'no' */

static double plot_data[MAX_POINTS+1][11]; /*[k][i] internal array*/
static double t_count=0;  /*internal time step*/
static int n=1;           /* current Replot (n.-ter) in current plot-diagramm */
static int n_cycle=1;     /* current cycle for x-range plotting  */
static int k=0;           /*aktueller Eintrag im plot_data-Array*/
static int graphs0=0,graphs1=0; /*number of graphs in plot 0&1*/
static double time_max;          /*from  par1 in [h] */
static double replot_time;       /*from  par2*/
static int online; /*par 7 */
static int unix2; /*par 8 */
static int ask;
static double ymin0=1e12;
static double ymax0=-1e12; /* auto-range */
static double ymin1=1e12;
static double ymax1=-1e12; /* auto-range */
double min0,max0,min1,max1;
int autorange=1;
int i; /* interner counter*/
char s[200],s_total[1000];



min0=par[unit][3]; /* ymin plot 0*/
max0=par[unit][4];
min1=par[unit][5];
max1=par[unit][6];
autorange=(int) par[unit][8];

/* ----------------------------------------init-------------------------------*/
if (init_flag) {
 int or_state=0; /* check inputs */
 unix2=(int) par[unit][8];
 online=(int) par[unit][7]; /* static */
 for (i=1;i<=10;i++) { if (in_u[unit][i]!=unit) or_state|=1; }
 if (or_state==1) online&=1;
 else             online=0; /* return on this */
 if (online==0) return(1);
 /*unix2=unix_flag;*/
 if (a) printf("unix2_flag :%d \n",unix_flag);
 unix2=unix_flag;
 ask=par[unit][9];

 time_max=par[unit][1]*3600; /* convert to [s] */
 if (online) replot_time=par[unit][2]*60; /* min-->sec */
 else        replot_time=time_max;
 if (replot_time< (time_max/MAX_POINTS) ) {
    printf("gnu_plotter: setting replot_time to:%.1fsec\n",replot_time);
    replot_time=time_max/MAX_POINTS;
exit (-1);
 }

 for (i=1;i<=5;i++) { 
   if ( (in_u[unit][i]!=0) && (in_nr[unit][i]<OUT_MAX0) ) graphs0=i;
//   else break;
 };
                     /*bestimme anzahl graphs0
                      out's von  unit 0 duerfen nicht geplottet werden!!*/
 for (i=6;i<=10;i++) { 
  if ( (in_u[unit][i]!=0) && ( in_nr[unit][i]<OUT_MAX0 ) ) graphs1=i-5;
//  else break;
 };

 if (online) {
   if ( (gnu1= (FILE*) 
               popen("gnuplot -noraise -geometry 600x200+10+10 -bg white","w"))
             == NULL) exit (-1);
   if (graphs1) {
      if ( ( gnu2=(FILE*)
              popen("gnuplot -noraise -geometry 600x200+10+250 -bg white","w")) 
                 == NULL) exit (-1);
   }
 } /* online */

 if (a) printf("Initialize of  GNUPLOT graphs0:%d  graphs1:%d \n",
        graphs0,graphs1);
}; /*end_initialize     */
/* ---------------------------------------------------------------------------*/
if (online==0) return(1);

/* -----------------------------write lines to   plot_data-Array*/

if ( t_count >= ((k+1)*(time_max/MAX_POINTS)) )
  {
    if (a) printf("t_count:%.1f plot_data-line:",t_count);

    if (time_max<=24*3600) plot_data[k][0]=tsim/3600;
    else                   plot_data[k][0]=day_of_year+tsim/(3600*24);
    if (a) printf("%.1f  ",plot_data[k][0]/3600);

    for (i=1;i<=(graphs0);i++)
      {
        if (out_o[unit][i+OUT_MAX0]==0) out_o[unit][i+OUT_MAX0]=1; 
           /*set default */
        plot_data[k][i]=out_o IN(i)*out_o[unit][i+OUT_MAX0]; /* init-factor  */
        if (a) printf("%.1f  ",plot_data[k][i]);
      };
    if (graphs1)
      {
        for (i=6;i<=(5+graphs1);i++)
          {
            if (out_o[unit][i+OUT_MAX0]==0) out_o[unit][i+OUT_MAX0]=1; 
            plot_data[k][i]=out_o IN(i)*out_o[unit][i+OUT_MAX0];
            if (a) printf("%.1f  ",plot_data[k][i]);
          };
      };
    if (a) printf("\n");
    if (k>=(MAX_POINTS-1)) k=0;
    else k++; /*Zeile von plot_data*/

  }
/* Format plot_data= ( 0..(graphs0+graphs1) )
                     ( .                    )
                     (.                     )
                     ( max_points-1...      )
*/

  /*------------------------------------------call replot--------*/
  if (   (t_count>=(n*replot_time-(int) h ) )
      || (t_count>=(time_max-(int) h )      )
     )
  {
  int j; /*counter*/

  if (a) printf("Replot Nr:%d   t_count:%.2f  time_max:%.2f  "
         "tsim: %.2f  \n",n,t_count,time_max,tsim);

  n++; /*n.ter replot*/

  if (n_cycle>REPLOT_MAX) {
    static int init_local=1;
    if (init_local) { 
     init_local=0; 
     pclose(gnu1);
     if (graphs1) pclose(gnu2);
     online=0; 
    }
    return(1); 
  } /*  */

  /*-----------write gnu plot-data file */

  if (a) printf("replot-call at tcount:%f   tsim=%f \n",t_count,tsim);
  if ((gnudata=fopen("plot.dat","w"))==NULL) 
    { printf("no gnuplot!\n"); /* exit (-1); */ }

  for (j=0;j<=(k-1);j++)                     /* write plot-data */
   {
   for (i=0;i<=graphs0;i++)
    {
    fprintf(gnudata,"%f  ",plot_data[j][i]);
    if (a)  printf("%f   ",plot_data[j][i]);
    if (plot_data[j][i]<ymin0) ymin0=plot_data[j][i];
    if (plot_data[j][i]>ymax0) ymax0=plot_data[j][i];
    };
   if (graphs1)
    {
    for (i=6;i<=(5+graphs1);i++)
     {
     fprintf(gnudata,"%f  ",plot_data[j][i]);
     if (a)  printf("%f   ",plot_data[j][i]);
    if (plot_data[j][i]<ymin1) ymin1=plot_data[j][i];
    if (plot_data[j][i]>ymax1) ymax1=plot_data[j][i];
     };
    };
    fprintf(gnudata," \n");
    if (a) printf("plot_data to plot.dat\n");
   };
/*
   ymin0=(int) (0.5+ymin0/10)*10;
   ymax0=(int) (0.5+ymax0/10)*10; 
   ymin1=(int) (0.5+ymin1/10)*10;
   ymax1=(int) (0.5+ymax1/10)*10; 
*/
   if (ymin0==ymax0) ymax0+=1;
   if (ymin1==ymax1) ymax1+=1;
  if (a) printf("ymin1:%.1f ymax1:%.1f \n",ymin1,ymax1);

  if (a) printf("fclose\n");
  fclose(gnudata);

     /*    "plot [0:3600][0:200]"*/

  s_total[0]='\0';
  if (autorange==1) { min0=ymin0; max0=ymax0; } 
  if (time_max<=24*3600) {
     sprintf(s,"plot [%.1f:%.1f][%.1f:%.1f] "
     ,(tsim-(n-1)*replot_time)/3600
     ,(tsim-(n-1)*replot_time+time_max)/3600,min0,max0);
     strcat(s_total,s);
  }
  else {
     sprintf(s,"plot [%.1f:%.1f][%.1f:%.1f] "
              ,(double) day_of_year+(tsim-time_max)/(3600*24.0)
              ,(double) day_of_year+tsim/(3600*24.0), min0,max0);
     strcat(s_total,s);
  }
  if (online) fflush(gnu1);

  for (i=1;i<=(graphs0);i++)
   {
   sprintf(s,"'plot.dat' us 1:"); strcat(s_total,s);
   sprintf(s,"%d",i+1); strcat(s_total,s);
   sprintf(s," ti \'scale:%.1e*out[%d,%d]=%s\' " /* 'out[%d,%d]' wi li" */
         ,out_o[unit][i+OUT_MAX0]
         ,in_u [unit][i]
         ,in_nr[unit][i],out_label[unit][i] );
   strcat(s_total,s);
   if (i!=graphs0) { sprintf(s,","); strcat(s_total,s); }
   };
   sprintf(s,"\n"); strcat(s_total,s);
   if (strlen(s_total)!=fprintf(gnu1,"%s",s_total) ) {
    printf("gnu_plotter: gnu1 string not written:\n"); exit (-1);
   }
   if (online) fflush(gnu1);

   if (a) printf("s_total[%d]:%s\n",strlen(s_total),s_total);
   if (graphs1 != 0) {
     s_total[0]='\0';
     if (autorange==1) { min1=ymin1; max1=ymax1; } 
     if (time_max<=24*3600) {
        sprintf(s,"plot [%f:%f][%f:%f] ",(tsim-(n-1)*replot_time)/3600,
                   (tsim-(n-1)*replot_time+time_max)/3600,min1,max1);
        strcat(s_total,s);
     }
     else {
       sprintf(s,"plot [%.1f:%.1f][%.1f:%.1f] "
               ,(double) day_of_year+(tsim-time_max)/(3600*24.0)
               ,(double) day_of_year+tsim/(3600*24.0), min1,max1);
       strcat(s_total,s);
     }

     for (i=(graphs0+1);i<=(graphs0+graphs1);i++) {
       sprintf(s,"'plot.dat' using 1:"); strcat(s_total,s);
       sprintf(s,"%d",i+1); strcat(s_total,s);
       sprintf(s," ti \'scale:%.1e*out[%d,%d]=%s\' " /* 'out[%d,%d]' wi li" */
           ,out_o[unit][i+OUT_MAX0+5-graphs0]
           ,in_u [unit][i-graphs0+5]
           ,in_nr[unit][i-graphs0+5],out_label[unit][i-graphs0+5] );
       strcat(s_total,s);
       if (i!=(graphs0+graphs1)) { sprintf(s,","); strcat(s_total,s); }
      }; /* for (i=(graphs0+1) .. */
      sprintf(s,"\n"); strcat(s_total,s);
      if (strlen(s_total)!=fprintf(gnu2,"%s",s_total) ) {
        printf("gnu_plotter: gnu2 string not written:\n"); exit (-1);
      } ; 
      if (online) fflush(gnu2);
      if (a) printf("s_total2[%d]:%s\n",strlen(s_total),s_total);
   }; /* if (graphs1 != 0) */
  };

t_count+=h;
if (   (t_count>=time_max) || (stop_flag) )
  {
    n_cycle++;
    n=1;k=0;t_count=0;
    if ( (online) && (ask))
      {
        char string[20]; 

        if ((no=fopen("no","r"))==NULL) { 
         printf("FileOpen error 'no'\n");exit (-1);}
         printf("continue ?? no:echo n>no, yes:echo y>no, cancel:echo c>no\n");
         printf("(menu:wake_up_function or use keyboard with stop:Ctr+S "
                "restart:Ctrl+Q\n");
        /* scanf("%c",string); */
        fscanf(no,"%c",string);
        while (string[0]=='n' || string[0]=='x' ) 
          { sleep(1);
          fclose(no);
          if ((no=fopen("no","r"))==NULL) 
             { printf("FileOpen error 'no'\n");exit (-1);}
          fscanf(no,"%c",string);
         /* konti */
          if (string[0]=='x' ) 
            {
            if (gnu1!=NULL) 
             {
             fprintf(gnu1,"set data style lines \n ");
             fprintf(gnu1,"set key right outside reverse\n ");
             fprintf(gnu1,"set size 1.4,.5\n ");
             fprintf(gnu1,"set origin -0.1,0.6 \n ");
             fprintf(gnu1,"set term fig color big \n ");
             fprintf(gnu1,"set output '.xfig'\n ");
             fprintf(gnu1,"replot\n");
             fprintf(gnu1,"set term x11\n");
             fprintf(gnu1,"reset\n");
             fflush(gnu1);
             }
            if (gnu2!=NULL) 
             {
             fprintf(gnu2,"set data style lines \n ");
             fprintf(gnu2,"set term fig color big \n ");
             fprintf(gnu2,"set output './tmp/fig2'\n ");
             fprintf(gnu2,"set size 1.4,1\n ");
             fprintf(gnu2,"set multiplot\n ");
             fprintf(gnu2,"set key right outside reverse\n ");              
             fprintf(gnu2,"set origin -0.1,0.1 \n ");
             fprintf(gnu2,"set size 1.4,0.5\n ");
             fprintf(gnu2,"replot\n");
             fprintf(gnu2,"reset\n");
             fprintf(gnu2,"set nomultiplot\n");
             fprintf(gnu2,"set term x11\n");
             fflush(gnu2);
             }
            if ( (FILE*) popen("tail -n +6 ./tmp/fig2 >> .xfig  ","w")==NULL)
             { 
             printf("no tail command found!! \n second gnuplot "
                    "window exportet to ./tmp/fig2 \n");
             exit (-1);
             } 
            else printf("actual gnuplot windows exportet to .xfig\n");

            fclose(no);
            if ((no=fopen("no","w"))==NULL) { 
              printf("FileOpen error 'no'\n");exit (-1);}
            fprintf(no,"n");
            string[0]='n';
            } /* end char=='x'  */
          }
        fclose(no);                            
        if (string[0]=='c') exit (-1);
        if (a) printf("going on \n");
      }
  }

return 1;
} /* gnu_plotter() */ 

