/* inc_angl_mod.interp.c */

/* 
001122 b0==-2 with iam table (1dim) declared 
010824 double *iam_diff added to inc_angl_mod2()
020304 iam_table added
       include "../iam/iam_table_long.dat" 
       include "../iam/iam_table_trans.dat" 
       pi=M_PI from math.h
*/
/*-----------------------incidence angle_modifier-iam---------------*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "global.h"

#define TRANS 1 /* iam in 2 directions transversal is usually hourangle */
#define LONG  2 /* depends on slope an sun position */
#define READ_IAM_TABLE 3 /* force init process */

double iam1d(int direction,double teta); /* 1d-table long and trans & init read */

/* lookup table 2d table */
double iam2d(double theta,double phi,double table_long [91],double table_trans[91] );

int get_iam_diffus(double *iam_diff); /* sphere integration isotrop */


/* old style inc_angl_mod precedure */
double inc_angl_mod(int init_flag, double b0, double teta,double phi
                    ,double **iam)
{
  int a=0;   /*-------------debug flag -----------------*/
  double inc_angl=0;
  int dist=0;
  int pos=0;
  double diff=0.0;
  double step=0.0;
  double pi=M_PI;
  double rad=pi/180;
  /* double tracked=1; */

  if (b0==-2)
   {
   /*                    0 10 20  30  40  50   60  70 80 90 */
   double iam_table[10]={1, 1, 1,0.9,0.8,0.9,0.85,0.6,0.3,0.0 };
   /*                    0  1  2   3   4   5    6   7   8   9 */
   int i_teta=(int) (teta/10.0+0.5);
   if (i_teta<0) i_teta=0;
   if (i_teta>9) i_teta=9;

   inc_angl=iam_table[i_teta];
   if (fabs(teta)>90) inc_angl=0;
   if (inc_angl<0)   inc_angl=0;
   if (inc_angl>1.2) inc_angl=1.2;
   if (a) printf("inc_angl: b0:%.4f teta:%.4f inc_angl:%.4f i:%d\n"
      ,b0,teta,inc_angl,i_teta);
   return (inc_angl);
   }
  if (b0!=-1) /*----------------------if bo -1 take iam-table -------------*/
   {

   b0=fabs(b0);
   if (fabs(teta)>90) inc_angl=0;
   else if (fabs(teta)>1) inc_angl=1-b0*(1/cos(teta*rad)-1);
        else              inc_angl=1; 

   if (inc_angl<0) inc_angl=0;
   if (inc_angl>1) inc_angl=1;
   if (a) printf("inc_angl:  b0:%.4f    teta:%.4f "
          "  inc_angl:%.4f \n",b0,teta,inc_angl);
   }
  else   /* ---------------------- take iam table from './iam/iam.dat' */
   {
   int cylinder_coordinates=1;

     /* static double iam[NR_TETA_MAX][NR_PHI_MAX]; buggy with to much elements */

   if (init_flag) 
     {
     FILE *iamfile;
     char line_array[200];
     char *line=line_array; 
     char *rest;
     double dummy;
     double fill=0;
     double teta_table[NR_TETA_MAX];
     int i_phi=0,i_teta=0,i_teta_max;
     
     if ((iamfile=fopen("./iam/iam_table.dat","r"))==NULL)
         { printf("no './iam/iam_table.dat' !! \n\n"); exit (-1); };
     fgets(line,200,iamfile); /* read headline and empty line .. skip */
     if (a) printf("last lin:%s\n",line);
     dummy=strtod(line,&rest);

     do {   /* scan all teta's in the headline */
       line= rest; 
       teta_table[i_teta]=strtod(line,&rest);
       if (a) printf("teta_table[%d]:%.2f \n",i_teta,teta_table[i_teta]);
       i_teta_max=i_teta;
       i_teta++;
       }
     while (teta_table[i_teta-1]<90);

     if (a) printf("headline ready\n");

     line=line_array;
     fgets(line,200,iamfile);  /* skip empty line */
 
     /* fill the iam arry with a dummy value */
     for   (i_teta=0;i_teta<=NR_TETA_MAX-1;i_teta++)
       for (i_phi =0;i_phi <=NR_PHI_MAX-1 ;i_phi++ ) iam[i_teta][i_phi]=XXX;

     while (fgets(line,200,iamfile)!=NULL)   /* read line */
       {
       phi=strtod(line,&rest);
       
       for (i_teta=0;i_teta<=i_teta_max;i_teta++)  /* scan all iams in this line */
        {
        line= rest;
        teta=teta_table[i_teta];
        iam[(int)   teta    ]
           [(int)  (phi+180)]=strtod(line,&rest);
        if (a) printf("iam_read: teta:%d phi+180:%d iam:%.2f \n"
                      , (int) teta,(int) (phi+180),iam[(int) teta]
                                                      [(int) (phi+180)] );
        }
        line=line_array;
       }
      fclose (iamfile);
      if ((iamfile=fopen("./iam/iam.dat","w"))==NULL)
         { printf("error open './iam/iam.dat' !! \n\n"); exit (-1); };
      
      fprintf(iamfile,"#teta phi iam \n#\n");


 /*Ermitteln der Abstaende der theta-werte, erwartet gleiche Abstaende zwischen
  allen theta und phi Werten in degree */
 
   dist=teta_table[1]-teta_table[0];
          
 /* lineares interpolieren zwischen den aus der Tabelle gelesenen theta-Werten fuer 
     in der Tabelle vorhandes phi,
     entspricht waagerechtem interpolieren in der Tabelle iam_file.dat */


     for  (i_phi=0;i_phi<=NR_PHI_MAX-1;i_phi+=dist){
           for  (i_teta=0;i_teta<=NR_TETA_MAX-2;i_teta++){ 
                pos=i_teta/dist;
                diff=iam[(pos+1)*dist][i_phi]-iam[pos*dist][i_phi];
                step=diff/dist;
                if  (iam[i_teta][i_phi]==XXX){
                   iam[i_teta][i_phi]=iam[pos*dist][i_phi]+step*(i_teta-pos*dist);
                }
                
          
            }
          
         }
/* lineares interpolieren zwischen den phi-Werten, jetzt fuer alle, auch die nur
   interpolierten theta-Werten,  
   entspricht senkrechtem Auffuellen der Tabelle iam_file.dat */

       for  (i_teta=0;i_teta<=NR_TETA_MAX-1;i_teta++){ 
             for  (i_phi=0;i_phi<=NR_PHI_MAX-2;i_phi++){
                pos=i_phi/dist;
                diff=iam[i_teta][(pos+1)*dist]-iam[i_teta][pos*dist];
                step=diff/dist;
                if  (iam[i_teta][i_phi]==XXX){
                   iam[i_teta][i_phi]=iam[i_teta][pos*dist]+step*(i_phi-pos*dist);
                }
             }
       }     

      /* now fill the rest of the iam-elements */
      for (i_teta=0;i_teta<=NR_TETA_MAX-1;i_teta+=5) {
        for (i_phi=0;i_phi<=NR_PHI_MAX-1;i_phi+=5) {
          if (iam[i_teta][i_phi]!=XXX) {   fill=iam[i_teta][i_phi]; }
          else                         {        iam[i_teta][i_phi]=fill; }
        if (cylinder_coordinates)
          fprintf(iamfile,"%.3f %.3f %.3f \n",sin((i_phi-180)*rad)*i_teta
                                             ,cos((i_phi-180)*rad)*i_teta
                                             ,iam[i_teta][i_phi]);
        else
          fprintf(iamfile,"%d %d %.3f\n",i_teta,i_phi-180,iam[i_teta][i_phi]);
        }
        fprintf(iamfile,"\n");
      }
      fclose (iamfile);
     printf("iam init done\n");
     } /* end of init iam-table--------------------------------------------------- */

    if (phi > 180) { printf("phi: %.2f set to  180\n",phi );phi = 180;};
    if (phi <-180) { printf("phi: %.2f set to -180\n",phi );phi =-180;};
    if (teta> 90 ) { /* printf("teta:%.2f set to   90\n",teta) */ ;teta=  90;};
    if (teta< 0  ) { printf("teta:%.2f set to    0\n",teta);teta=   0;};


      inc_angl=iam[(int) (teta)]
                  [(int) ( phi+180)] ;
      if ( (a) || (inc_angl>1.3) || (inc_angl<0) )
                printf("iam[teta:%d][phi:%d-180]:%.2f phi:%.2f teta:%.2f\n"
                ,(int) (teta),(int) ( phi+180),inc_angl,phi,teta);
     }

/* if (tracked ) inc_angl=1.00; */
return (inc_angl);
}


double inc_angl_mod2(int init_flag, double b0, double teta,double phi,
                     double *iam_diff)
{
  int a=0;   /*-------------debug flag -----------------*/
  double inc_angl=0;
  double pi=M_PI;
  double rad=pi/180;
  static int local_init=1;
  static double **iam;  /* for iam-table */
  if ( local_init ) { local_init=0;
   iam=malloc_2double(NR_TETA_MAX,NR_PHI_MAX);
  }

  /* double tracked=1; */
  if ( /*(int)*/ (b0)==-1)  { /* on b0==-1 use 2D table iam_table_trans.dat
                             iam_table_long.dat */
   if (init_flag) {  /* read iam table */
     int check=0;
     if ((int) (*iam_diff)!=-1) {
       printf("inc_angl_mod2: iam_diff:%.2f!=-1:, auto-calc \n",*iam_diff);
       exit (-1);
     }
     iam1d(READ_IAM_TABLE,1);
     if ( (int) (*iam_diff)==-1) get_iam_diffus(iam_diff); /* rewrite iam_diffus  Bestest:0.872  */
     if (check) {
       printf("test iam_transversal[86.5]:%.6f iam_diff:%.4f \n",iam1d(TRANS,86.5),*iam_diff);
       printf("test iam[theta:120.3][phi:0]:%.6f  \n",iam2d(120.3,0,NULL,NULL));
       exit (-1);
     }
   }
   inc_angl=iam2d(teta,phi,NULL,NULL); /*  theta, phi */

   /* iam_table((int) b0,iam_diff,teta,&inc_angl );  use table */
   if (0) printf("iam_diff:%.2f teta:%.1f phi:%.1f inc_angl:%.2f\n"
                 ,*iam_diff,teta,phi,inc_angl);
   return (inc_angl);
  } /*  (b0==-1) */

/* --------------- simple table ---------------------------------------------*/
  if (b0==-2)
   {
   /*                    0 10 20  30  40  50   60  70 80 90 */
   double iam_table[10]={1, 1, 1,0.9,0.8,0.9,0.85,0.6,0.3,0.0 };
   /*                    0  1  2   3   4   5    6   7   8   9 */
   int i_teta=(int) (teta/10.0+0.5);
   if (i_teta<0) i_teta=0;
   if (i_teta>9) i_teta=9;

   inc_angl=iam_table[i_teta];
   if (fabs(teta)>90) inc_angl=0;
   if (inc_angl<0)   inc_angl=0;
   if (inc_angl>1.2) inc_angl=1.2;
   if (a) printf("inc_angl: b0:%.4f teta:%.4f inc_angl:%.4f i:%d\n"
      ,b0,teta,inc_angl,i_teta);
   return (inc_angl);
   }
  if (b0!=-1) /*----------------------standard ambrositti iam formulation--*/
   {

   b0=fabs(b0);
   if (fabs(teta)>90) inc_angl=0;
   else if (fabs(teta)>1) inc_angl=1-b0*(1/cos(teta*rad)-1);
        else              inc_angl=1; 

   if (inc_angl<0) inc_angl=0;
   if (inc_angl>1) inc_angl=1;
   if (a) printf("inc_angl:  b0:%.4f    teta:%.4f "
          "  inc_angl:%.4f \n",b0,teta,inc_angl);
   }

/* if (tracked ) inc_angl=1.00; */
return (inc_angl);
} /* inc_angl_mod2 */


/* :r  ~chrwi/prg/iam/iam_3d/iam3d.c */

double iam1d(int direction,double teta) {
/*
read iamtable long and transversal via include directive
at init, it generated a table table_long and table_trans in degrees

*/
 int i;
 double table[91];
 static double table_long [91];
 static double table_trans[91];
 static int init=1;

 if (init) { /* get 1 degree table with linear approx */
  FILE *iam_file;
  char filename[30];
  int a=0;
  init=0;
  /* bestest 
  table[0 ]=0.787;table[10]=0.786;table[20]=0.785;table[30]=0.780;
  table[40]=0.767;table[50]=0.737;table[60]=0.666;table[70]=0.518;
  table[80]=0.266;table[90]=0;
  */
  /* floatglas werner platzer 
  table[0 ]=0.923;table[ 5]=0.923;table[10]=0.923;table[15]=0.923;
  table[20]=0.923;table[25]=0.922;table[30]=0.920;table[35]=0.917;
  table[40]=0.913;table[45]=0.904;table[50]=0.891;table[55]=0.870;
  table[60]=0.836;table[65]=0.785;table[70]=0.708;table[75]=0.596;
  table[80]=0.441;table[85]=0.240;table[90]=0.000;
  */

  /* read iam_table_trans.dat i-----------------------------------------*/
  for (i=0;i<=90;i++) table[i]=0;
  #include "iam_table_trans.dat" /* read table */
  sprintf(filename,"iam/iam.dat");
  for (i=0;i<90;i++) { /* run thru table array and search for non-zero's */
   int i1=1,i2=0;
   while ( (table[i+i1]==0) && ( (i+i1)<90) ) {i1++;};
   for (i2=i+1;i2<=i+i1-1;i2++) { /* white linear approximation to table */
    table[i2]=table[i]+(i2-i)*(table[i+i1]-table[i])/(i1+1e-12);
    if (a) printf(" table[%d]:%f\n",i2,table[i2]);
   }
   i+=i1; /* skip to next entry e.g. table[15] */
   if (a) printf("i:%d i1:%d table[%d]:%f\n",i,i1,i,table[i]);
   i-=1; /* dec to prevent double inc from for next loop */
  } /* i++ */
  for (i=90;i>=0;i--) {  /* get normalized iam table (iam(0)=1 !! ) */
    if (table[0]==0) { printf("iam[0]==0!! exit\n");exit(-1); }
    else table[i]/=table[0];
  } /* i-- */
  for (i=0;i<=90;i++) table_trans[i]=table[i]; /* write to static array */

  /* read iam_table_trans.dat -----------------------------------------*/
  for (i=0;i<=90;i++) table[i]=0;
  #include "iam_table_long.dat" /* read table */
  sprintf(filename,"iam/iam.dat");
  for (i=0;i<90;i++) { /* run thru table array and search for non-zero's */
   int i1=1,i2=0;
   while ( (table[i+i1]==0) && ( (i+i1)<90) ) {i1++;};
   for (i2=i+1;i2<=i+i1-1;i2++) { /* white linear approximation to table */
    table[i2]=table[i]+(i2-i)*(table[i+i1]-table[i])/(i1+1e-12);
    if (a) printf(" table[%d]:%f\n",i2,table[i2]);
   }
   i+=i1; /* skip to next entry e.g. table[15] */
   if (a) printf("i:%d i1:%d table[%d]:%f\n",i,i1,i,table[i]);
   i-=1; /* dec to prevent double inc from for next loop */
  } /* i++ */
  for (i=90;i>=0;i--) {  /* get normalized iam table (iam(0)=1 !! ) */
    if (table[0]==0) { printf("iam[0]==0!! exit\n");exit(-1); }
    else table[i]/=table[0];
  } /* i-- */
  for (i=0;i<=90;i++) table_long[i]=table[i]; /* write to static array */

 /* white table to dat file --------------------------------------------*/
 if ((iam_file=fopen(filename,"w"))==NULL)
        { printf("error file open '%s' !! \n\n",filename); exit (-1); };

 fprintf(iam_file,"#teta[] iam_trans[1] iam_long[1]\n#\n");
 for (i=0;i<=90;i++)  fprintf(iam_file,"%d %f %f\n"
                                  ,i,table_trans[i],table_long[i]); 
 fclose(iam_file);
 iam2d(0,0,table_trans,table_long); /* init table 2d */
 } /* init() */


if (direction==READ_IAM_TABLE) return (0.0);
else {
 if (direction==TRANS) return ( table_trans[(int) (teta+0.5)] );
 else                  return ( table_long [(int) (teta+0.5)] );
} /* return iam value */

} /* iam() */


double iam2d(double theta,double phi,double table_long [91],double table_trans[91] ) 
{
/* get 2d table of iam with table_long and table_trans degree table 
   2d table is written at init, 2nd time lookup table is used, use
   NULL pointers at 2nd time call for table_long,table_trans arrays
*/
int a=0;
double iam;
int plot_file=1;
static int init=1;
static double iam2d_table[91][91]; /* theta,phi */
int phi_str; /* used to reduze iam array to phi=0..90 */


#define EMPTY -99


if (a) printf("try: init:%d phi:%.1f teta:%.1f\n",init,phi,theta);
if (theta>90)  return (0.0); /* iam =0 */

if (init) { /* create 2d table */
  int phi,theta;
  init=0;
  for (theta=0;theta<=90;theta+=1) {
   for (phi=0;phi<=90;phi+=1) {
    iam2d_table[theta][phi]= /* y=mx+b */
     table_trans[theta]-  (double) phi*(table_trans[theta]
                                       -table_long[theta])/90.0;
    if (isnan(iam2d_table[theta][phi])) {
      printf("iam2d_table[%d][%d]:%.1f \n",theta,phi,iam2d_table[theta][phi]);
      exit (-1);
    }
    if ( (iam2d_table[theta][phi]<0) || (iam2d_table[theta][phi]>1.5) )
      iam2d_table[theta][phi]=EMPTY;
    
    if (a) printf("iam2d theta:%d phi:%d iam:%.4f \n",theta,phi,
          iam2d_table[theta][phi]);
   } /* phi */
  } /* theta */

  if (plot_file) { /* print 2d plot 10degrees steps*/
   char filename[30];
   FILE *iam_file;
   int phi,theta;

   /* write 3d table */
   sprintf(filename,"iam/iam3d.dat");
   if ((iam_file=fopen(filename,"w"))==NULL)
        { printf("error file open '%s' !! \n\n",filename); exit (-1); };
   if (0) fprintf(iam_file,"#phi theta iam3d_phi_theta\n#\n");
   for (phi=0;phi<=360;phi+=5) {
     for (theta=0;theta<=90;theta+=10) {
      if (1) fprintf(iam_file,"%d.0 %d.0 %.4f \n",phi,theta,iam2d(theta,phi,NULL,NULL));
     } /* theta */
   } /* phi */
   fclose(iam_file);

#if 1
   /* write 2d table for 10 phi's */
   for (phi=0;phi<=90;phi+=10) {
     sprintf(filename,"iam/iam2d_phi%d.dat",phi);
     if ((iam_file=fopen(filename,"w"))==NULL)
        { printf("error file open '%s' !! \n\n",filename); exit (-1); };
     fprintf(iam_file,"#phi theta iam2d_table\n#\n");
    for (theta=0;theta<=90;theta+=1) {
     if (1) fprintf(iam_file,"%d %d %.4f \n",phi,theta,iam2d_table[theta][phi]);
    } /* teta */
   fclose(iam_file);
   } /* phi */
#endif
  } /* plot_file */
} /* init */

if (!init) {
 /* get phi_str for iam table for phi = 0..360 degr */

 //quadrant=phi-phi%90;
 phi_str=phi;
 if ( (phi>90 ) && (phi<=180) ) phi_str=180-phi;
 if ( (phi>180) && (phi<=270) ) phi_str=phi-180;
 if ( phi>270 ) phi_str=360-phi;
 if (phi_str>90) { printf("exit on phi:%d \n",phi_str); exit (-1); }

//if ( (quadrant==0) || (quadrant==270) ) phi_str=    phi-quadrant;
//else                                    phi_str=90-(phi-quadrant);
 iam=iam2d_table[ (int) (theta+0.5) ][ (int) (phi_str+0.5) ];
 if (isnan(iam) ) { printf("iam:%.2f \n",iam); exit (-1); }
}
return iam;
}; /* iam2d() */

int get_iam_diffus(double *iam_diff)
{
/* get surface of half squere in discrete pieces to multiply
  iam-correction in dependence of incidence angle
 get mantel of half sphere

 bronstein s.200 
 kugelmantel M=4*pi*r2

 M=2*pi*R*h wobei h die hoehendiffenernz von
 winkel alpha und beta ist
*/
double a,b,h;
double i_alpha,delta_alpha=1; /* alpha=0=normal vector */
double i_phi,delta_phi=1;
double rad=M_PI/180;
double deltaM=0,M=0; /* mantel-guertel */
double R=1; /* radius */
double x1,x2,y1,y2;
double alpha,beta;
double p_ges;

p_ges=*iam_diff=0; /* reset unit power and iam_function */

/* step with 1 degree steps along the shell */
for (i_phi=0;i_phi<=360-delta_phi;i_phi+=delta_phi) { 
    /* linear steps around the circle*/
  for (i_alpha=0;i_alpha<=90-delta_alpha;i_alpha+=delta_alpha) {
   alpha=i_alpha;
   beta=i_alpha+delta_alpha;

   x1=cos(alpha*rad);y1=sin(alpha*rad); /*get hight-difference via cart coord*/
   x2=cos(beta*rad); y2=sin(beta*rad);
 
   a=x1;
   b=x2;
   h=y2-y1;
   deltaM=2*M_PI*R*h/(360/delta_phi);
   if (0) printf("alpha:%.2f x1:%.4f y1:%.4f x2:%.4f y2:%.4f deltaM:%.4f\n"
               ,alpha,x1,y1,x2,y2,deltaM);
   M+=deltaM;
   /* *iam_diff+=deltaM*iam(TRANS,i_alpha)*sin(alpha*rad); / * delta_A*iam */
   *iam_diff+=deltaM*iam2d((int) (90.5-i_alpha),(int) (i_phi+0.5),NULL,NULL)*sin(alpha*rad); /*delta_A*iam*/
   p_ges   +=deltaM*1.0               *sin(alpha*rad) ;
  } /* i_alpha */
 } /* i_phi */
*iam_diff/=(p_ges);

return (1);
} /* get_iam_diffus () */



