/* init_set_mp.c  */
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/
/*

25/02/00 pipe_air, mixer_air and diverter_air included 
26/02/00 pointer stacks are eleminated for air_units (select_unit[] method)
000728 case 53 created for dec-type53 hydraulic-type 53,priority 6
001121 pump_completed return first to ioen diverter than heatexch.
001130 count inputs up to INPUT_MAX , some comments
010124 christiane: corrected bug in vector completion of mixer_air
010612 chriwi: case 57 routing input 2 buggy

when creating new hydralic types, update  hydraulic type definition !! 
insert a new case to the type list (case type) where the outgoing path
out_nr is defined .

*/

#include "global.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*------------------------------------------set_mp()--------*/
int init_set_mp(double **par,int **in_u,int **in_nr,double **out_o,
           double **out_n,int *type,int pump_nr,int *pump_unit,
           int coll_pipe_nr,int *coll_pipe_unit,
           double tsim,int un_max,char **type_def_str,
           int i_div,int *div_unit,int mp_change,int init_flag,
           int **active_circle)
{
int a=0;  /*--------------ANALYSE mit a=1---------*/

int i_pump,i,i1;
int nr_of_circles=0;
int select_unit[UNIT_MAX]; /* check number of call of current unit */
int input_select=0;
int hydraulic_type=0; /* is this type hydraulic !! update the types */
      
/* recognize output changes */
double out_analyse_o[UNIT_MAX+1][OUT_MAX0]; 

int  Div_nr[DIV_NR];
int *Div_stack=Div_nr;       /* unit of the current Flow_Dive MAX=20*/
int  mixer_st[DIV_NR],exchr_st[DIV_NR],exchr_st2[DIV_NR]; /*max number */

int *mixer_stack_unit=mixer_st;  /* unit of the current mixer */
int *exchr_stack_unit=exchr_st;
int *exchr_stack_unit2=exchr_st2;
int *mix_pointer=mixer_st;
int *exc_pointer=exchr_st;
int mixer_st_in[DIV_NR],exchr_st_inp_nr [DIV_NR],exchr_st_inp_nr2[DIV_NR];
int *mixer_stack_inp1=mixer_st_in; /* mp of 1.input of current mixer */
   
int *exchr_stack_inp_nr =exchr_st_inp_nr;
int *exchr_stack_inp_nr2=exchr_st_inp_nr2;
int *inp_pointer=mixer_st_in;

int i_unit;  /*current unit */
int unit_pointer=0;
int previous_unit;
int out_nr; /* current output-nr of mp */
int circle1=0; /* max one circle searching last unit !!*/
int pump_circle_break=0; /*flag set if there is a mixer with unknown input2 */
int found=0; /* flag set if a mixer was registrated earlier */

for (i=1;i<=un_max;i++) select_unit[i]=0; /* reset selects */

/* now set Pump-outs -------------set_mp()----------------------- */
if (a) printf("init_set_mp: pump_nr:%d pump_unit[1]:%d\n",pump_nr,pump_unit[1]);

for (i_pump=1;i_pump<=(pump_nr);i_pump++)
 {
 pump_circle_break=0; /* search each unit of the current pump-circle */
 nr_of_circles++;

 if (a)
  {
  printf("\nstarting with pump-circle unit:%d\n",pump_unit[i_pump]);
  /* store old state */
  for (i=1;i<=un_max;i++)
    for (i1=1;i1<=18;i1++) out_analyse_o[i][i1]=out_n[i][i1];
  }

  i_unit=pump_unit[i_pump]; /* unit-nr of current pump */

  active_circle[i_pump][1]=i_unit;
  unit_pointer=1;         /* pointer for active circle array */

  previous_unit=i_unit;
  out_nr=2; /* mp_out of pump und collecting-pipe */
out_nr=1; /* experimental !!!!!!!!!!!!!! */

  /* search next unit */

  do  /*exit if i_unit=current pump or unknown mixer */
   {
      /*----------------search following unit ----------*/

   circle1=0; /* limit circles to 1 */
   do /* run through pump-circle */
     {
     i_unit++;
     if (i_unit>un_max) { i_unit=1; circle1++; } /* only one circle!! */

     /* updated version of input-selection check */
     input_select=0;          /* hydraulic type definition !! */
hydraulic_type=1; /* !!!!!!!! ??????? */


     /* scan inputs i of the current unit for input-connections */
     i=0; do { i++;
             if (( in_u  [i_unit] [i] ==previous_unit )
               &&( in_nr [i_unit] [i] ==out_nr )
               &&(hydraulic_type) )
                 {
                 input_select=i;
                 if (a) printf("hydraulic unit[%d] found with inp:[%d]\n"
                               ,i_unit,input_select);
                 }
             if (0) printf("i_unit:%d type:%d hyd:%d input_sel:%d "
                           "previous_unit:%d in_u[i_unit] [i]:%d\n"
               ,i_unit,type[i_unit],hydraulic_type,input_select,previous_unit
               ,in_u[i_unit][i]);
             } while ( (i<INPUT_MAX) && (input_select==0) );

if (a) printf("2:i_unit:%d type:%d hyd:%d input_sel:%d\n"
,i_unit,type[i_unit],hydraulic_type,input_select);


     }
   while ( (input_select==0) && (circle1<2) ) ; /* search following unit */

   if (circle1>=2)
     {
     printf("init_set_mp: no connection found, when searching a following"
            " unit to: [%d][%d]  ([unit][output]) \n",previous_unit,out_nr
           );
     exit (-1);
     }
    /*-------- end of searching following unit-------*/

   if (a)  printf("%2d: i_unit:%2d  input_select:%d \n"
                  ,unit_pointer,i_unit,input_select);
   if (a)  printf("Input:%d  [%d,%d] found \n",
           input_select,previous_unit,out_nr); 

          /*set unit order */
   unit_pointer++;       /* pointer for active circle array */
   active_circle[i_pump][unit_pointer]=i_unit;
   active_circle[i_pump][unit_pointer+1]=0; /*reset for end-label */
   if (a) printf("in_init_set_mp %d\n",type[i_unit]);
   switch (type[i_unit])
     {
     case 1: /*---earlier type collector , now 1-port-in 1-port-out-fluid-*/
       for (i=2;i<=2;i++) { /* vector completion: input 1..2 */
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                      in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
         };
       out_nr=1; /* exp */
       break;
     case 3: /*-------pump fluid ---*/
         {
         for (i=2;i<=2;i++) { /* vector completion: input 1..2 */
           if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                        in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
           };
         if (   (Div_stack==Div_nr) /*no registrated diverter */
                 && (exchr_st2==exchr_stack_unit2) /*no reg exch  */
                    ) 
            {
            pump_circle_break=1; /* next pump circle */
                if (a) printf("change pump-circle \n\n");
            break;
            }
                  /* same procedure for heatechanger and other 4 pols */
          if ( exchr_st2 != exchr_stack_unit2) /* last complete hexch */
             {
             out_nr=*exchr_stack_inp_nr2; /* e.g. out2-->out2 */
             i_unit=*exchr_stack_unit2;
             exchr_stack_inp_nr2--;
             exchr_stack_unit2--;
                            
             if (a) printf("\npump_unit, going back to last "
                                  "heatexchg. unit:%d out_nr:%d\n\n"
                                  ,i_unit,out_nr);
              /* bug: 5/97 heatexchnger and pump */
             unit_pointer++;       /* pointer for active circle array */
             active_circle[i_pump][unit_pointer]=i_unit;
             active_circle[i_pump][unit_pointer+1]=0; /*reset for end-label */
             break;
             }
         if ( Div_stack!=Div_nr) /* registrated diverter */
            {
            /* back to previous diverter */
            Div_stack--;
            i_unit=*Div_stack;
                    if (a) printf("\npump_unit, going back to last "
                                          "diverter unit:%d\n",i_unit);
            out_nr=3; /* experimental */
            /* bug: 5/97 diverter  */
            unit_pointer++;       /* pointer for active circle array */
            active_circle[i_pump][unit_pointer]=i_unit;
            active_circle[i_pump][unit_pointer+1]=0; /*reset for end-label */
            break;
            }
          break;  
          }
     case 4: /*-----------------------------Storage ---------------------------*/
       for (i=2;i<=2;i++) { /* vector completion: input 1..2 */
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                      in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
         };
       for (i=4;i<=4;i++) { /* vector completion: input 3..4 */
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][3];
                                      in_nr[i_unit][i]=in_nr[i_unit][3]-3+i;
         };
       for (i=6;i<=6;i++) { /* vector completion: input 9..10*/
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][5];
                                      in_nr[i_unit][i]=in_nr[i_unit][5]-5+i;
         };
       for (i=8;i<=8;i++) { /* vector completion: input 17.18*/
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][7];
                                      in_nr[i_unit][i]=in_nr[i_unit][7]-7+i;
         };
       if ( input_select==1 ) /* wt2 inlet */  { out_nr=1 ;  /* mp_wt2-outlet */ break; }
       if ( input_select==3 ) /* KW */         { out_nr=3 ;  /* mp_KW-outlet  */ break; }
       if ( input_select==5 ) /* wt1,heater */ { out_nr=9 ;  /* wt1-outlet    */ break; }
       if ( input_select==7 ) /* circ_in */    { out_nr=17;  /* circ_outlet   */ break; }
       printf("error input-connections storage2 \n");
       exit (-1);
     case 10: /*-------HEATEXCH TYPE 10 heatexchanger--- */
         for (i=2;i<=2;i++) { /* vector completion: input 1..2 */
           if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                        in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
           };
         for (i=4;i<=4;i++) { /* vector completion: input 3..4 */
           if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][3];
                                        in_nr[i_unit][i]=in_nr[i_unit][3]-3+i;
           };
       if ( input_select==1 )  out_nr=1;  
       else                    out_nr=3;  
                   
          /* new version 1/97 : take static exchanger, complete inputs */
          /* first heatexch, it's undefinded, may be 0 */
       inp_pointer=exchr_stack_inp_nr; /*pointer on current echger */
       exc_pointer=exchr_stack_unit;   /* input_nr & unit_nr */
       exc_pointer++; /* inc */
       inp_pointer++;
       if (a) printf("i_unit:%d heatexchanger\n",i_unit);
       if (a) printf("exchr_stack_inp_nr:%d\n"
                                "exchr_stack_unit:%d\n",*exchr_stack_inp_nr
                                                       ,*exchr_stack_unit);
       do /* search hex in list */
                    {
                    exc_pointer--;
                    inp_pointer--;
                    if (i_unit==*exc_pointer) found=1;
                    else                      found=0;
                    if (a) printf(" searching current exchanger in stack:%d found:%d\n"
                                                    ,*exc_pointer,found);
                    }
                    while (     (exc_pointer !=  exchr_st   )
                             && (i_unit      != *exc_pointer)
                          );
                  if (!found) /* store current */
                    {
                    exchr_stack_unit++;
                    exchr_stack_inp_nr++;
                    *exchr_stack_unit   = i_unit;
                    *exchr_stack_inp_nr = out_nr; /* 2; chriwi bug 8/99 
                                                     swapped hex-inputs */
                    if (a) printf("exchr not found !,but stored:%d \n"
                                  ,exchr_stack_unit-exc_pointer );
                    pump_circle_break=1;
                    if (a) printf("--> new pump! \n");
                    }
                  else  /* exchr is registrated, found=1 */
                    {
                    out_nr=*exchr_stack_inp_nr; /* e.g. out2-->out2 */
                    /* set complete heatexchanger for closed pump circle*/
                    exchr_stack_unit2++; /* use second stack to jump back */
                    exchr_stack_inp_nr2++;
                    *exchr_stack_unit2=i_unit; /*!!!! bug 4/98 (zenit) 
                                                   *exchr_stack_unit;*/
                    if (out_nr==1) *exchr_stack_inp_nr2=3;
                    else           *exchr_stack_inp_nr2=1;
                            
                    if ( exc_pointer!=exchr_stack_unit) /* not last element */
                      { /* move last element into space */
                      *inp_pointer=*exchr_stack_inp_nr; /* last element */
                      *exc_pointer=*exchr_stack_unit; /*last element */
                      } 
                    exchr_stack_inp_nr--; /* dec orig exch input_nr & unit array */
                    exchr_stack_unit--;
                    
                    if (a) printf("complete exchg unit:%d set out_nr:%d\n"
                             ,i_unit,out_nr);
                    if (a) printf("store: *exchr_stack_unit2:%d\n",*exchr_stack_unit2);
                    found=0;
                    }
                  break;   
     case 11: /*---------------- Flow_Div */
         for (i=2;i<=2;i++) { /* vector completion: input 1..2 */
           if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                        in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
           };
                  if (a)
                    printf("Div_stack_unit:%d  store in divStack \n",i_unit);
                  *Div_stack++ = i_unit; /* store unit */
                  out_nr=1;
                  break;
     case 13: /*----------------- Mixer --*/
         for (i=2;i<=2;i++) { /* vector completion: input 1..2 */
           if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                        in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
           };
         for (i=4;i<=4;i++) { /* vector completion: input 3..4 */
           if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][3];
                                        in_nr[i_unit][i]=in_nr[i_unit][3]-3+i;
           };

                  /* search mixer in stack */
                  inp_pointer=mixer_stack_inp1;
                  mix_pointer=mixer_stack_unit;
                  mix_pointer++; /* inc */
                  inp_pointer++;
                  do
                    {
                      mix_pointer--;
                      inp_pointer--;
                      if (i_unit==*mix_pointer) found=1;
                      else                      found=0;
                      if (a) printf(" search current mixer in stack:%d\n"
                                    ,*mix_pointer);
                    }
                  while (     (mix_pointer !=  mixer_st   )
                           && (i_unit      != *mix_pointer)
                        );
                  if (!found) /* store the current */
                    {
                      mixer_stack_unit++;
                      *mixer_stack_unit = i_unit;
                      /* proof, if there is a privious diverter */
                      if (a) printf("mixer not found ! \n");

                      if (Div_stack==Div_nr)
                        {
                          pump_circle_break=1;
                          if (a) printf(" no current diverter-->new pump! \n");
                          break;
                        }
                      else /* there is one, go back */
                        {
                          Div_stack--;
                          i_unit=*Div_stack;
                          if (a)
                            printf("going back to diverter unit:%d \n",i_unit);
                          out_nr=3;

                          /*set unit order */
                        unit_pointer++;       /* pointer for active circle array */
                        active_circle[i_pump][unit_pointer]=i_unit;
                        active_circle[i_pump][unit_pointer+1]=0; /*reset for end-label */
                        }
                    }
                   else  /* mixer is registrated */
                     {
                     if ( mix_pointer==mixer_stack_unit) /* last stored mixer */
                       {
                       /* mixer input 2 or a
                       first mixer without previous diverter*/
                       mixer_stack_inp1--;
                       mixer_stack_unit--;
                       if (a) printf("mixer completet\n");
                       out_nr=1;
                       }
                      else
                       {
                       /* I've found the mixer in the middle of the stack */
                       /* now fill the space with last element */
                       /* set outs */
                       i_unit=*mix_pointer;
                       out_nr=1;
                       if (a)
                       printf("mixer out unit:%d = %d \n" ,*mix_pointer,
                              *inp_pointer *3600);
                       /* change elements */
                       *inp_pointer=*mixer_stack_inp1; /*last element */
                       mixer_stack_inp1--;
                       *mix_pointer=*mixer_stack_unit; /*last element */
                       mixer_stack_unit--;

                       found=0;
                       }
                     }
                  break;


/*----------------------------------------------------------------------------*/
     case 32: 
       out_nr=1;  /*--- pipe_air.c ----- */
       if (1) printf("\n");
       for (i=2;i<=5;i++) { /* vector completion: input 1..5 *!!!!!!!!!!!!!!!!!!!!!!!*/
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                      in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
         if (1) printf("pipe_air: i:%d update vector in_u[%d][%d] = %d and  out_nr=%d\n"
                     ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
         }
       break; 
/*----------------------------------------------------------------------------*/
     case 47: /* ----------DIVERTER_AIR --------------------------------*/
                  select_unit[i_unit]+=1;
                  out_nr=1;
                  if (a) printf("diverter_air detected \n");
                  for (i=2;i<=5;i++) { /* vector completion: input 1..5 !!!!!!!!!!!!*/
                   if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                                in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
                   }
                  break;
     case 48: /*---------MIXER_AIR    ---------------------------*/
                  if (select_unit[i_unit]==1) /* 2nd call */
                    { 
                    out_nr=1; 
                    for (i=2;i<=5;i++) { /* vector completion: input 1..5 !!!!!!!!!!*/
                     if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                                  in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
                     }
                    for (i=7;i<=10;i++) { /* vector completion: input 1..5 !!!!!!!!! */
                     if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][6];
                                                  in_nr[i_unit][i]=in_nr[i_unit][6]-6+i;
                     }
                    break; 
                    } 
                  else   /* 1st call */
                   {
                   int i=0,stop=0;
                   do {   /* search unsolved diverter,which was called once  */
                      i++;
                      if (0) printf("mixer_air:i:%d type[%d]:%d\n",i,i,type[i]);
                      if (i>=un_max) stop=1;
                      if ((select_unit[i]==1) && (type[i]==47)) stop=1;
                      } while ( !stop );
                   if (i>un_max) { printf("mixer_air[%d]:i:%d no diverter found \n"
                                      ,i_unit,i); exit (-1);  }
                   if (a) printf("mixer_air[%d]: diverter[%d] found,going back "
                                 "with out_nr=9  \n" ,i_unit,i);
                   select_unit[i_unit]=1;
                   i_unit=i; /* go back to diverter */
                   select_unit[i_unit]+=1; /* inc diverter counter */
                   out_nr=9;
            unit_pointer++;       /* pointer for active circle array */
            active_circle[i_pump][unit_pointer]=i_unit;
            active_circle[i_pump][unit_pointer+1]=0; /*reset for end-label */
                   }
                  break;
     case 49: /*---------PUMP_AIR -------------------------------*/
         for (i=2;i<=5;i++) { /* vector completion: input 1..5 !!!!! */
                   if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                                in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
                   }
                  break;
     case 50: /*---------HEATER_AIR------------------------------*/
                  for (i=2;i<=5;i++) { /* vector completion: input 1..5 !!!! */
                   if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                                in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
                   }
                  out_nr=1;
                  break;
     case 52: /*--------ADSORBER_HM-adsorber_hm.c--------------*/
       if  (input_select==1) {
         printf("adsorber_hm  %d  !\n",in_u [i_unit][1]);
         if (1) printf("\n");
         for (i=2;i<=5;i++) { /* vector completion: input 1..5 *!!!*/
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                      in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
         if (1) printf("adsorber_hm: i:%d update vector in_u[%d][%d] = %d "
                       "and  out_nr=%d\n"
                       ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
         } /* vector compl */
         out_nr=1;
       } /* input_select==1 */
       else {
          printf("adsorber_hm backflow  at unit %d !\n",in_u [i_unit][10]);
          for (i=11;i<=14;i++) { /* vector completion: input 10..14 *!!!!!!!*/
            if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][10];
                                        in_nr[i_unit][i]=in_nr[i_unit][10]-10+i;
            if (1) printf("adsorber_hm: i:%d update vector in_u[%d][%d]=%d and "
                        "out_nr=%d\n"
                        ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
          } /* ector compl */
          out_nr=10;
       } /* input_select!=1 */
       break;
     case 53: /*--------ADSORBER ---adsorber.c-----------------*/
       if  (input_select==1) {
         printf("adsorber     %d  !\n",in_u [i_unit][1]);
         if (1) printf("\n");
         for (i=2;i<=5;i++) { /* vector completion: input 1..5 *!!!*/
         if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                      in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
         if (1) printf("adsorber   : i:%d update vector in_u[%d][%d] = %d "
                       "and  out_nr=%d\n"
                       ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
         } /* vector compl */
         out_nr=1;
       } /* input_select==1 */
       else {
          printf("adsorber    backflow  at unit %d !\n",in_u [i_unit][10]);
          for (i=11;i<=14;i++) { /* vector completion: input 10..14 *!!!!!!!*/
            if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][10];
                                        in_nr[i_unit][i]=in_nr[i_unit][10]-10+i;
            if (1) printf("adsorber   : i:%d update vector in_u[%d][%d]=%d and "
                        "out_nr=%d\n"
                        ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
          } /* ector compl */
          out_nr=10;
       } /* input_select!=1 */
       break;
     case 54: /* HYDRAULIC 54 reformer.c */
       i=26;
       if (in_u[i_unit][i]==i_unit) {
         in_u [i_unit][i]=in_u [i_unit][25];
         in_nr[i_unit][i]=in_nr[i_unit][25]+1; /* out_nr10 (9+1) */
         }
       out_nr=41; /* go further with out41 */
     case 55: /* HYDRAULIC 55  pem.c FluidIn input14 FluidOut Out18 */
       i=15;
       if (in_u[i_unit][i]==i_unit) {
         in_u [i_unit][i]=in_u [i_unit][14];
         in_nr[i_unit][i]=in_nr[i_unit][14]+1; /* out_nr10 (9+1) */
         }
       out_nr=19; /* go further with out19 */
       break;
     case 57: /*---------ROTATION_EX----rotation_ex.c----------*/
       if  (input_select==1) {
          printf("rotation_ex at unit %d  !\n",in_u [i_unit][1]);
          if (1) printf("\n");
          for (i=2;i<=5;i++) { /* vector completion: input 1..5 *!!!!!!!!*/
            if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][1];
                                         in_nr[i_unit][i]=in_nr[i_unit][1]-1+i;
            if (1) printf("adsorber: i:%d update vector "
                          "in_u[%d][%d] = %d and  out_nr=%d\n"
                ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
          }
          out_nr=1; 
       } /* if input_select==1 */
       else {
          for (i=11;i<=14;i++) { /*vector comp input 10..14 *!!!!*/
            if (in_u[i_unit][i]==i_unit) in_u [i_unit][i]=in_u [i_unit][10];
                                         in_nr[i_unit][i]=in_nr[i_unit][10]-10+i;
            if (1) printf("adsorber: i:%d update vector in_u[%d][%d] "
                        "= %d and  out_nr=%d\n"
                        ,i,i_unit,i,in_u [i_unit][i],in_nr[i_unit][i]);
          }
          out_nr=10;
       } /* else input_select==1 */
        break;
     case 75: /* HYDRAULIC 75 ex_gas_liq.c FluidIn input 9 FluidOut OUT 12 */
       i=10;
       if (in_u[i_unit][i]==i_unit) {
         in_u [i_unit][i]=in_u [i_unit][9];
         in_nr[i_unit][i]=in_nr[i_unit][9]+1;
         }
       out_nr=12; /* go further with out12 */
       break;
     case 76: /* HYDRAULIC 76 ex_gas_liq_new.c FluidIn input 12 FluidOut OUT 15 */
       i=13;
       if (in_u[i_unit][i]==i_unit) {
         in_u [i_unit][i]=in_u [i_unit][12];
         in_nr[i_unit][i]=in_nr[i_unit][12]+1; /* out_nr13 (12+1) */
         }
       out_nr=15; /* go further with out15 */
       break;
     default: 
        printf("unknown hydraulic unit:%d type:%d\n",i_unit,type[i_unit]); 
        exit(-1); 
        break;

     }; /*end_case_switch */

     previous_unit=i_unit;
  } /* ---search following unit - */
  while (   (i_unit != pump_unit[i_pump]) /*exit current pump-circle */ 
          &&(!pump_circle_break));

 }; /*next i_pump: i_pump=1;i_pump<=(pump_nr);i_pump++)  */


/*--------------------end of set_mp()-------------------------------*/

return (nr_of_circles);
}

