/* init_type_def_str.c */

#include "global.h"
#include <stdio.h>
#include <stdlib.h>

/* this precedure defines the type names. it is also
used to define the corresponding source file names,
which is used by etc/sort_xfig graphic object 
when creating new type define the comment 
update main() with unit_order and new case_type
and update init_set_mp, where hydraulic unit_order is
generated by searching input connections 
 
010710 chriwi syntax
011116 HydResist added
020319 add reformer types at type_no 70 ff
 */

/*-----------------------------------init_type_def_str---------*/
int init_type_def_str(char **type_def_str)
{
  int k1,i;
  static char str[TYPES_MAX][TYPES_STRING_LENGTH]={    /*  use correct comments !!! */
    {"!!!!!!!!!   "},
    {"COLLECTOR   "}, /* TYPE 1  : SOURCE collector.c      */
    {"CONTROLLER  "}, /* TYPE 2  : SOURCE controller.c     */
    {"PUMP        "}, /* TYPE 3  : SOURCE pump.c           */
    {"STORAGE     "}, /* TYPE 4  : SOURCE storage.c        */
    {"TAP         "}, /* TYPE 5  : SOURCE water_drop.c     */
    {"AUX.HEATER  "}, /* TYPE 6  : SOURCE heater.c         */
    {"COLLECT_PIPE"}, /* TYPE 7  : SOURCE collecting_pipe.c*/
    {"HEATING     "}, /* TYPE 8  : SOURCE heating.c        */
    {"WEATHER_READ"}, /* TYPE 9  : SOURCE weather.c        */
    {"HEAT_EXCH   "}, /* TYPE 10 : SOURCE heatexchanger.c  */
    {"DIVERTER    "}, /* TYPE 11 : SOURCE diverter.c       */
    {"HEATPUMP    "}, /* TYPE 12 : SOURCE heatpump.c       */
    {"MIXER       "}, /* TYPE 13 : SOURCE mixer.c          */
    {"LOAD_PROFILE"}, /* TYPE 14 : SOURCE load.c           */
    {"LOAD_CONTROL"}, /* TYPE 15 : SOURCE load_control.c   */
    {"CONTR_SOLAR "}, /* TYPE 16 : SOURCE controller.c     */
    {"CONTR_HEATER"}, /* TYPE 17 : SOURCE controller.c     */
    {"CONTR_CIRCLE"}, /* TYPE 18 : SOURCE controller.c     */
    {"FUZZY_CNTRL "}, /* TYPE 19 : SOURCE fuzzy_controller.c*/
    {"ZONE_ROOM   "}, /* TYPE 20 : SOURCE zone.c              */
    {"LAYER       "}, /* TYPE 21 : SOURCE layer.c             */
    {"ABSORBER    "}, /* TYPE 22 : SOURCE absorber.c          */
    {"RC          "}, /* TYPE 23 : SOURCE RC.c                */
    {"EQUATION    "}, /* TYPE 24 : SOURCE equation.c          */
    {"PRINTER     "}, /* TYPE 25 : SOURCE printer.c           */
    {"CONTROLLER_X"}, /* TYPE 26 : SOURCE controller_x.c      */
    {"EQUATION_X  "}, /* TYPE 27 : SOURCE equation_x.c        */
    {"WALL        "}, /* TYPE 28 : SOURCE wall.c              */
    {"AIRRAD_NODE "}, /* TYPE 29 : SOURCE AirRad_node.c       */
    {"            "},
    {"PIPE        "}, /* TYPE 31 : SOURCE pipe2.c             */
    {"PIPE_AIR    "}, /* TYPE 32 : SOURCE pipe_air.c          */
    {"MASS_ELEMENT"}, /* TYPE 33 : SOURCE mass_element.c      */
    {"max_test    "}, /* TYPE 34 : SOURCE max_test.c          */
    {"hydraulic   "}, /* TYPE 35 : SOURCE hydraulic.c         */
    {"valve       "}, /* TYPE 36 : SOURCE valve.c             */
    {"read_data   "}, /* TYPE 37 : SOURCE read_data.c         */
    {"HydResist   "}, /* TYPE 38 : SOURCE HydResist.c         */
    {"            "},
    {"MAX_TESTOGL "}, /* TYPE 40 : SOURCE max_testogl.c         */
    {"            "},
    {"            "},
    {"            "},
    {"            "},
    {"            "},
    {"            "},
    {"DIVERTER_AIR"}, /* TYPE 47 : SOURCE diverter_air.c      */
    {"MIXER_AIR   "}, /* TYPE 48 : SOURCE mixer_air.c         */
    {"PUMP_AIR    "}, /* TYPE 49 : SOURCE pump_air.c          */
    {"HEATER_AIR  "}, /* TYPE 50 : SOURCE heater_air.c        */
    {"            "},
    {"adsorber_hm "}, /* TYPE 52 : SOURCE adsorber_hm.c       */
    {"ADSORBER    "}, /* TYPE 53 : SOURCE adsorber.c          */
    {"reformer    "}, /* TYPE 54 : SOURCE reformer.c          */
    {"pem         "}, /* TYPE 55 : SOURCE pem.c               */
    {"HUMIDIFIER  "}, /* TYPE 56 : SOURCE humidifier.c        */
    {"ROTATION_EX "}, /* TYPE 57 : SOURCE rotation_ex.c       */
    {"DECprinter  "}, /* TYPE 58 : SOURCE DECprinter.c        */
    {"DECcontrol  "}, /* TYPE 59 : SOURCE DECcontroller.c     */
    {"heatexch_air"}, /* TYPE 60 : SOURCE heatexchanger_air.c */
    {"shading     "}, /* TYPE 61 : SOURCE shading.c           */
    {"SIM_CONTROL "}, /* TYPE 62 : SOURCE main.c              */
    {"            "}, 
    {"            "},
    {"GNU-PLOTTER "}, /* TYPE 65 : SOURCE gnu_plotter.c       */
    {"            "}, /* TYPE 66 : SOURCE                     */
    {"            "}, /* TYPE 67 : SOURCE                     */
    {"            "}, /* TYPE 68 : SOURCE                     */
    {"            "}, /* TYPE 69 : SOURCE                     */
    {"fuzz_control"}, /* TYPE 70 : SOURCE fuzz_control.c      */
    {"pi_control  "}, /* TYPE 71 : SOURCE pi_control.c        */
    {"ventilator  "}, /* TYPE 72 : SOURCE ventilator.c        */
    {"bhkw_control"}, /* TYPE 73 : SOURCE bhkw_control.c      */
    {"dc_ac       "}, /* TYPE 74 : SOURCE dc_ac.c             */
    {"ex_gas_liq  "}, /* TYPE 75 : SOURCE ex_gas_liq.c        */
    {"reformer_det"}, /* TYPE 76 : SOURCE reformer_det.c      */
    {"energy_sink "}, /* TYPE 77 : SOURCE energy_sink.c       */
    {"preprecontr "}, /* TYPE 78 : SOURCE preprecontr.c       */
    {""}

 };


  for (k1=0;k1<TYPES_MAX;k1++)
    {
      for (i=0;i<=(TYPES_STRING_LENGTH-2);i++)
        {
          type_def_str[k1][i]=str[k1][i];
         /* printf("%1c",str[k1][i]);*/
        };
      type_def_str[k1][TYPES_STRING_LENGTH-1]=':';
     /*  printf("\n"); */
    };
  return 1;
} /*init_type_def_str */

