/*  load.c   */          
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/

#include "global.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* 
000310 load_reader substituded through load() i
000609 bug fix out-timestep
000621 if ( time_intervall!=0) exit (-1);
000626 scanf(zeile) extended to 30 entries
000726 read_line_counter added to detect empty lines in load.dat
000831 CHARS_OF_LINE defined to chars 400 , Zeile subst. to line[]
010312 comment lines '#' detected
010627 skip_time_intervall added to load_init header
       time_in_sec%skip_time_intervall used to check valid entries for FastIt
011207 add par2 to use out6,7,8 for load.dat outs, not for sys energy 
011219  get_words_of_line() added
020321 exit on par2 (allouts) error
020531 LOAD_SIZE removed, dyn. alloction with load.dat size checking
*/

#define COL_MAX 50          
/* #define LOAD_SIZE 5000       / * lines in load[]  */
#define CHARS_OF_LINE 1000

int get_words_of_line(char *line,int chars_of_line,int col_max,
      char str[COL_MAX+1][80],int i_line);
 
/*------------------------LOAD_READER-TYPE 14---------------------------------*/
int load(unit,par,out_o,out_n,tsim,day_of_year,day_of_week,skip_time_intervall)
           int unit;   /* current unit number */
           double **par;  /* parameter array par[unit][1..PARMAX] */
           double **out_o; /* output array with privious state */
           double **out_n; /* output array with current state */
           double tsim;    /* tsim  */
           int day_of_year;
           int day_of_week;
           double skip_time_intervall;
{
/* xfig.awk

   TYPE      14
   PRIORITY  1  1st rang
   HYDRAULIC 99 non_hydraulic

   PAR1: 86399 [s] 'dt' timeintervall 0:default 24h, else count par1-seconds  
   PAR2: 1     [1] 'allouts' use out 6,7,8 for load-dat out 

   input only used, to define weekend

   INP1: 1 [1] if 1: out1=0 at weekend
   INP2: 1 [1] if 1: out2=0 at weekend
   INP3: 1 [1] if 1: out2=0 at weekend
   INP4: 1 [1] if 1: out2=0 at weekend

   OUT1: [1] 'out1' outs from load.dat
   OUT2: [1] 'out2' 
   OUT3: [1] 'out3' 
   OUT4: [1] 'out4' 
   OUT5: [1] 'out5' 
   OUT6: [1] 'out6' 
   OUT7: [1] 'out7' no sys gain any more
   OUT8: [1] 'out8' 
   OUT9: [1] 'out9' 
   OUT10: [1] 'out10' 
   OUT11: [1] 'out11'
   OUT12: [1] 'out12' 
   OUT13: [1] 'out13' 
   OUT14: [1] 'out14' 
   OUT15: [1] 'out15' 
   OUT16: [1] 'out16' 
   OUT17: [1] 'out17' 
   OUT18: [1] 'out18' 
   OUT19: [1] 'out19' 
   OUT20: [1] 'out20' 



*/
                                                            
int a=0; /*--------debug------------------------------------------------------*/
static int point_line=0,day_start;    /* point on new line */
static int init_flag=1; 
static double n;                    /* loop n */
static double zyklus;
static double **load;
int i=1,i1;
int columns_max=(int) out_o[unit][OUT_MAX0+1];   
double time;
int allouts=(int) par[unit][2]; /* flag to use all outs for load.dat */

if (a) printf("load: 0..columns_max=%d\n",columns_max);

if (init_flag) {  /* init, get load[][] array etc ..*/
  FILE *pos;
  int columns_max,count=0;
  char line[CHARS_OF_LINE];
  char str[COL_MAX+1][80];      /*words in this line */
  int lines_max=0; /* get number of lines of load.dat */
  int words_max=0; /* get words of load.dat */

  init_flag=0;
  if ( !( ( allouts==0) || (allouts==1) ) ) { /* check par2 */
   printf("load[%d]: error par2\n",unit); exit (-1);
  }

  /* read load.dat file to get columns_max&line_max */
  if ( (pos=fopen("load.dat","r"))==NULL) {
   printf("load.c:load.dat not existant  \n"); exit (-1);
  }
  while (  (fgets(line,CHARS_OF_LINE,pos)) !=NULL) {
   if ((line[0]!='#')  && (lines_max!=1) ) /* 2nd line could be empty */
    columns_max=get_words_of_line(line,CHARS_OF_LINE,COL_MAX,str,count);
   if (columns_max>words_max) words_max=columns_max;
   lines_max++;
  };

  /* size lines_max , columns_max */
  load=(double**) malloc(sizeof(double*)*(lines_max+1)); /* LOAD_SIZE */
  for (i1=0;i1<=lines_max;i1++) /* LOAD_SIZE */
   load[i1]=(double*) malloc(sizeof(double)*(words_max+2) ); /* OUT_MAX */
  if (load==NULL) { printf("malloc ERROR *load \n"); exit (-1); };
  if (a) printf("load_read: malloc done, try to load_init\n");
  zyklus=load_init(unit,par,out_o,out_n,load,skip_time_intervall,lines_max);
  if (a) printf("load_read: load_init done\n");
  point_line=0;
  n=0;
  day_start=day_of_year;
  columns_max=(int) out_o[unit][OUT_MAX0+1];   
} /* init */
time = n*zyklus+load[point_line][0]; /* absolute in [s] */
if (a) printf("load_read: time read done tsim:%.1f day_of_year:%d "
              "day_start:%d time:%.1f columns_max:%d\n"
               ,tsim,day_of_year,day_start,time,columns_max);
if (a) printf("load_read: n:%.3f zyklus:%.4f load[point_line][0]:%.4f "
              "tsim:%.4f arg:%.4f arg-time:%e\n"
              ,n,zyklus,load[point_line][0],tsim,
              (double) (day_of_year-day_start)*86400,
              fabs((tsim+ (  (double) (day_of_year-day_start)*86400) )-time) );


/* if ( fabs((tsim+ (  (double) (day_of_year-day_start)*86400) )-time) >= 0 ) */
if ( (tsim+ (  (double) (day_of_year-day_start)*86399) ) >=time)
  {
  if (a) printf("Day of week: %d, par[%d]=%f \t n:%.1f columns_max:%d \n"
                 , day_of_week, i, par[unit][i],n,columns_max);
  if (a) printf("n=%.1f  tsim+day= %.1f  next_time_load= %.1f \n",n
               ,tsim+(day_of_year-day_start)*86400, time /*-n*zyklus*/ );
  if (time>=(n+1)*zyklus) {point_line=0;n+=1;}
  for (i=1;i<=(columns_max);i++)
    {
    /* Attention LOAD_READER out6,7,8 are energy outs !!!!!!*/
    if ( (i>=6) && (!allouts) ) i1=i+3;
    else                        i1=i;

    if (    ( (int) out_n[unit][i+OUT_MAX0]==1 )    /*  weekend ? */
              && ( (day_of_week==0 || day_of_week==6) ) 
       ) {
       out_n[unit][i1]=out_o[unit][i1]=0;
       printf("load[%d] weekend profile ! remove this exit \n",unit); 
       exit (-1);
       }
    else {
       out_n[unit][i1]=out_o[unit][i1]=load[point_line][i];
    }
    if (a) printf("tsim:%.1f out[%d]: %.4f pointer_line:%d\n",tsim,i1
                  ,out_n[unit][i1],point_line);
    };
   if (a) printf("\n");
  point_line++;
  } ; /* next cycle */

if (a) 
 printf("load.c: tsim:%.1f time_next:%.1f out1:%.1f ... out[%d]:%.2f\n",
       tsim,time,out_n[unit][1],columns_max,out_n[unit][columns_max]);
return 1;
} /* load() */







/*--------------------------------load_init-----------------------------------*/

double load_init(unit,par,out_o,out_n,load,skip_time_intervall,lines_max)
 int unit;
 double **par;
 double **out_o;
 double **out_n; 
 double **load;
 double skip_time_intervall; /* check load.dat entries regarding
                                          to skip_time_intervall */
 int lines_max;
 /*return timeintervall */
{

const int a=0; /*-------------debug ---------*/
FILE *pos;
char line[CHARS_OF_LINE];
char *rest;
char str[COL_MAX+1][80];      /*words in this line */
int count=0;                        /* no of this line */
int k;                            /* internal counter*/
double time1,time1_old=0,time_in_sec,time_in_sec0;   /*end_time,start_time */
int hour,min,sec;
int columns_max=0;
double zyklus;                    /*timeintervall read from database */
int read_line_counter=0;
double time_intervall=par[unit][1]; /* to check cycle */

if (a) printf("load_init: skip_time_intervall:%.2f \n",skip_time_intervall);

if (time_intervall==0) time_intervall=23*3600+59*60+59; /* default day */

if ( (pos=fopen("load.dat","r"))==NULL) { 
  printf("load.c:load.dat not existant  \n");
  if ( time_intervall!=0) exit (-1);
  return -1;
}

if (fgets(line,CHARS_OF_LINE,pos)==NULL)
   { printf("error load.dat \n"); exit (-1); };

columns_max=get_words_of_line(line,CHARS_OF_LINE,COL_MAX,str,count);

out_n[unit][OUT_MAX0+1]=out_o[unit][OUT_MAX0+1]=columns_max; /* store it */

if (0) printf("\ncolumns_max:=%d\n",columns_max);

for (k=0;k<=columns_max;k++) printf("%s ",str[k]); /* Print Headline*/
printf("\n");

fgets(line,CHARS_OF_LINE,pos); /*empty line */
if (  (strlen(line)>2) &&(line[0]!='#') ) 
   { printf("\nload.c:2nd line should be empty:%s.end\n",line);exit (-1);  }

count=0;
while ( (fgets(line,CHARS_OF_LINE,pos)!=NULL) && (count<=lines_max)  
         && (line[0]!='#') ) /* LOAD_SIZE */
 {
  int columns_of_this_line=0;
  if (count>=lines_max) {
   printf("load_init: database >lines_max:%d\n",lines_max); exit (-1);
  }
  columns_of_this_line=get_words_of_line(line,CHARS_OF_LINE,COL_MAX,str,count);
  if ( columns_of_this_line!=columns_max) {
   printf("load_init: error reading line:%d of load.dat columns_max:%d=:%d !\n",
           count+2,columns_max,columns_of_this_line);
  }
  if (a) printf("\ncolumns_max:=%d\n",columns_max);
 if (strstr( str[0],"#")==NULL) { /* valid data line */
  for (k=0;k<=columns_max;k++) if (str [k][0]=='\0') { 
    printf("load.dat line:%d value:%d empty\n" ,count+2,k); exit (-1); }

       time1=strtod(str[0],&rest);
  if ( (count>1) && (time1_old>=time1) )
    { printf("load.dat line:%d time error time1_old:%f time1:%f time_str:%s\n"
            ,count+2,time1_old,time1,&str[0][0]); exit (-1);
    }                                  
  time1_old=time1;
      
  if (a)  printf("load.dat line:%d difftime:%.2f :"
                ,count+2,time1_old-time1);

  if (!(  (strlen(str[0])==6) || (strlen(str[0])==7)  ) )
     { printf("error load_profile time:%s \n",str[0]); }

  if (strlen(str[0])==6) { /* this is assembler like !!,  ascii programming */
    hour=10*((int) str[0][0]-48)+1*((int) str[0][1]-48);
    min =10*((int) str[0][2]-48)+1*((int) str[0][3]-48);
    sec =10*((int) str[0][4]-48)+1*((int) str[0][5]-48);
  }
  if (strlen(str[0])==7) {
    hour=100*((int) str[0][0]-48)
         +10*((int) str[0][1]-48)+1*((int) str[0][2]-48);
    min = 10*((int) str[0][3]-48)+1*((int) str[0][4]-48);
    sec = 10*((int) str[0][5]-48)+1*((int) str[0][6]-48);
  }

  if (a) printf("HH:%d MM:%d SS:%d :",hour,min,sec);

  load[count][0]=(double) hour*3600+(double) min*60+(double) sec;


  for (k=1;k<=columns_max;k++) load[count][k]=strtod(str[k],&rest);
  if (strlen(str[columns_max+1])!=0) {
   printf(" load.dat: more columns as declared in headline columns_max:%d "
          "dataline:%d \nstrlen:%d string:0x%x\n",columns_max,read_line_counter
          ,strlen(str[columns_max+1]),str[columns_max+1][0]);
   exit (-1);
  }

  if (a) { for (k=0;k<=columns_max;k++) { printf("%f  ", load[count][k] ); };
            printf("\n");
  };

  time_in_sec=(double) (hour)*3600+(double) (min)*60+(double) sec;

  /* check time_in_sec due to FastIteration skip_time_intervall's
     timeentries should be mod-time sequences to skip intervalls 
     don't look to the last entrie with mmss:5959 , new sequence begins there 
  */
  if (skip_time_intervall>0) {
   if (   ( ((int) time_in_sec) % ( (int) skip_time_intervall) !=0) 
        &&( time_intervall!=time_in_sec )  /* exclude end of sequence */
      )
      { /* use mod */
      printf("load_init: load.dat:  hhmmss:%2d%2d%2d \n skip_time_intervall:"
             "%.1f is not a multiplier of time_in_sec:%.0f\n",
             hour,min,sec,skip_time_intervall,time_in_sec);
      exit (-1);
   } /* if time_in_sec%skip_time_intervall!=0 */
  } /* if (skip_time_intervall>0) */
  if (count==0) {     /*if 1st line of data */
    time_in_sec0=time_in_sec;
    if (time_in_sec!=0) {
     printf("first line in load.dat not 000000 !!:hour:%d min:%d sec:%d\n"
            ,hour,min,sec);
     exit(-1);
    };
    out_n[unit][0]=out_o[unit][0]=time_in_sec;
    for (k=1;k<=columns_max;k++)
    if (k<6) out_n[unit][k  ]=out_o[unit][k  ]=load[0][k];
    else     out_n[unit][k+3]=out_o[unit][k+3]=load[0][k];
  }; /* if count==0, first_line */
  count++;
  }; /* valid readline */
 }; /* while readline loop */
zyklus=(double) hour*3600+(double) min*60+(double) sec-time_in_sec0;
if (a) printf("par1:%.1f load-dat-time_intervall:%.1f time_in_sec0:%.1f "
               "hour:%.1f\n"
              ,zyklus,time_intervall,time_in_sec0,(double) hour);
if (fabs(zyklus-time_intervall)>=1) { /* check sequence with parameter */
   printf("time_intervall of 'load.dat' is different from parameter1 of "
          "load_reader\nerror load_time_intervall:%.2f par1:%.2f \n",
           zyklus,time_intervall); 
   exit (-1);
} /* check sequence */

if (count>lines_max) /* LOAD_SIZE  */
  printf("\n\nlines_max too small for 'load.dat'  !!!\n\n\n");
fclose(pos);

return zyklus;  /* tell duration of load-intervall */
} /* load_init() */

int get_words_of_line(char *line,int chars_of_line,int col_max,
      char str[COL_MAX+1][80],int i_line) 
{
int a=0;
int k,i;
char *str_pointer[COL_MAX];   /* point to column string */
int columns_max=0;

for (k=0;k<=OUT_MAX0;k++) str [k][0]='\0';

k=0; /* number of words */
str_pointer[k]=&line[0]; /* point to first string */
i=0; do {  /* check number of chars in headline */
 if (i>chars_of_line) { 
   printf("load.c: number of chars:%d >CHARS_OF_LINE\n", i);
   exit (-1); 
 }  
 if (   ( (line[i]==' ') && (line[i+1]!=' ' ) 
       && (line[i+1]!=0) && (line[i+1]!=0x0a) )   ) { 
  k++; /* on space inc number of words */
  str_pointer[k]=&line[i]; str_pointer[k+1]=0; /* null */
  if (a) printf("k:%d str_pointer:0x%x%x line[i,i+1]:0x%x%x \n"
   ,k,str_pointer[k][0],str_pointer[k][1],line[i],line[i+1]);
 } 
 if (k>col_max) { printf("load.c: number of words:%d >COL_MAX:%d\nline:%s"
                  ,k,col_max,line ); exit (-1); }  
 i++;
} while (line[i]!='\0');

columns_max=k; /* 0:time 1..columns_max */
if (columns_max>=OUT_MAX0) { printf("load.c: columns_max:%d OUT_MAX0:%d\n",
  columns_max,OUT_MAX0); exit (-1); 
}
 
for (k=0;k<=OUT_MAX0;k++) str [k][0]='\0'; /* init words */
  
k=0; do { 
 if (sscanf(str_pointer[k],"%s",str [k])==EOF) { 
  printf("load.c:error reading line:%d column:%d of load.dat/empty line \n"
   ,i_line,k);  
  exit (-1);
  }
 else { 
  if (0) printf("scan:%d:%s\n",k,str [k]);
  str [k+1][0]='\0';
 }
 k++;
} while (str_pointer[k]!=0); 
/*
while ( (str[columns_max][0]!='\0') && (columns_max<OUT_MAX0) ) columns_max+=1;
columns_max-=1; / * column 0:time 1:out1 2:out2 ...columns_max:out_columns_max * /
*/
if (a) printf("returning columns_max:%d\n",columns_max);
return (columns_max);
} /* get_words_of_line() */
