/* printer.c */
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/


#include "global.h"
#include <stdio.h>
#include <stdlib.h>

/*
001109 headline included with char***out_label
010118 sum algorithm moved to end of code; mean&integral over last timeintervall
010212 current value moved to out_o array (was buggy)
010221 i_total bug fix
010523 some syntax modifictaions
010605 year 00 printer bug , if par4==0 time=Y/M/D/H/M/S
011206 labels update
*/
/*------------------------------------------------------PRINTER---TYPE25-----*/
int printer(unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,tsim,init_flag,
            year_start,day_of_year,month,day,hour,min,sec,day_flag,week_flag,
            hour_flag, min10_flag,stop_flag,un_max,out_label,type_index)
           int    unit;      /* current unit number */
           double **par;     /* parameter array par[unit][1..PARMAX]  */
           int    **in_u;    /* input unit array, input connections   */
           int    **in_nr;   /* input number array                    */
           double **out_o;   /* output array with privious state      */
           double **out_n;   /* output array with current state       */
           double **deriv_o; /* derivatives: used for diffential equ. */
           double **deriv_n; /*  new state of deriv                   */
           double h;         /* sim time step                         */
           double tsim;      /* simulation time in [s] of this day    */
           int    init_flag; /* set at initial loop of sim            */
           int year_start;  /* filename generate */
           int day_of_year;
           int month;
           int day;
           int hour;
           int min;
           int sec;
           int day_flag;
           int week_flag;
           int hour_flag;
           int min10_flag;
           int stop_flag;
           int un_max;
           char ***out_label;  /* headline of printer */
           int    *type_index; /* index of calling this type          */

{
/*   ./etc/xfig.awk
     
    TYPE 25
    PRIORITY  15         used by config routine
    HYDRAULIC 99         used by config routine

     
     PAR1: 0 [1] 'file_nr' file_nr 0..9, (set input-initials: 0:mean,1:curr,2:integr,3:sum)
     PAR2: 0 [s] 'dt' print-intervall in sec, used only if par3==0
     PAR3: 4 [1] 'dt_mode' 0:use par2, 1=year,2=month,3=week,4=day,5=hour,6=10min,7=min,8=sec
     PAR4: 0 [1] 'timeformat' time:0=YYMMDDHHMMSS,1=SecOfYear,2=hour,3=day,4=min
     PAR5: 1 [1] 'scaling' output in kWh: mode 0:Ws 1:kWh,(integral&sum)
     PAR6: 0 [1] 'buffer' 0:no fflushFlag 1: writes immediatly to file 3: ignore printer
     
     INP1: 1 [1] 'in1' init values : 0:mean,1:curr,2:integr,3:sum
     INP2: 1 [1] 'in2'
     INP3: 1 [1] 'in3'
     INP4: 1 [1] 'in4'
     INP5: 1 [1] 'in5'
     INP6: 1 [1] 'in6'
     INP7: 1 [1] 'in7'
     INP8: 1 [1] 'in8'
     INP9: 1 [1] 'in9'
     INP10: 1 [1] 'in10'
     INP11: 1 [1] 'in11'
     INP12: 1 [1] 'in12'
     INP13: 1 [1] 'in13'
     INP14: 1 [1] 'in14'
     INP15: 1 [1] 'in15'
     INP16: 1 [1] 'in16'
     INP17: 1 [1] 'in17'
     INP18: 1 [1] 'in18'
     INP19: 1 [1] 'in19'
     INP20: 1 [1] 'in20'

     input_initials: for processing input-data set following
                     initial values for each channel
                  (init1-->out_n[unit][k+OUT_MAX0]...)
        preset   0 = meanvalue,
                 1 = current value, (default) 
                 2 = integral (Q+=P*h)
                 3 = sum,     (Q+=dQ)
                 
     ----------- differences of inp[k] & [k+1] --> out[k]=column[k]

                 20=diff out[k+1]-out[k];meanvalue
                 21=diff out[k+1]-out[k];current value
                 22=diff out[k+1]-out[k];integral
                 23=diff out[k+1]-out[k]; sum (dQ_in-dQ_out))
     OUT1: [1] 'out1' outs not used at printers
     OUT2: [1] 'out2' 

     deriv 1 internal set :  nr_of_columns
     deriv 2 internal set :  counter for time-intervall
     deriv 3 internal set :  nr_of_meanvalues
*/

#define MAX_PRINTER 10 /* 0..9 */
  int a=0; /*--------------debug with  a=1---------*/
  int file_nr=(int) par[unit][1];        /*file */

  static FILE *sim_out[11];              /* datafile for printers */
  
  double deltaT;        /*time_intervall*/
  int nr_of_mean=(int) deriv_o[unit][3];
  int k,k1; /* internal counter*/
  int nr_of_columns; /* --> deriv1 */
  int print_flag=0;

  int fflushFlag=(int) par[unit][6];
  static char file_name[] ="sim_outx.dat";
  char        file_name2[]="sim_outx.dat";
  int i;  
  int printer_index=type_index[unit]; /* for some malloc data */
  static int i_total[MAX_PRINTER];
  static double min_total[MAX_PRINTER][OUT_MAX0],max_total[MAX_PRINTER][OUT_MAX0];
  static double sum_total[MAX_PRINTER][OUT_MAX0];

  if (fflushFlag==3) return(1); /*ignore printer */

  if (init_flag)
    {
      /*-------------------------------generate output-file-name -*/
      if (file_nr>MAX_PRINTER-1) {
       printf("printer[%d]:par1:%d error\n",unit,file_nr); exit (-1);
      }
      if (a) printf("---------------printer unit:%d no:%d\n",unit,(int) file_nr);
      /* init i_total,min_total,sum_total array */
      i_total[printer_index]=0;
      for (i=0;i<OUT_MAX0;i++) {
       min_total[printer_index][i]= 1e12;
       max_total[printer_index][i]=-1e12;
      }
      sprintf(file_name2,"sim_out%d.dat",(int) file_nr);
      if ((int) file_name2[7]==(int) file_name[7]) 
                { printf("same filnr:%d as last time unit:%d '%c=%c'\n"
                      ,(int) file_nr,unit,file_name2[7] ,file_name[7]); 
                  printf("file_name_new:%s file_name_previous:%s \n",
                          file_name2,file_name); exit (-1); }
      for (k=1;k<=13;k++) file_name[k]=file_name2[k];

      if ( ((int) file_nr<0) || ((int) file_nr>9 ) ) 
        { printf("error filnr:%d unit:%d\n",(int) file_nr,unit);
          exit (-1);
        }
      if (a) printf("file_name:%s unit:%d\n",file_name,unit);

      if ((sim_out[file_nr]=fopen(file_name,"w")) == NULL)
             { printf("datafile '%s' open error \n",file_name);exit(-1); }
        
         /*---------------get number of columns to print & initialize */
         k=INPUT_MAX+1;
         do  k--; 
         while (   (   (in_u[unit][k]==unit) 
                    || (in_u[unit][k]==0) 
                   )
                && (k>0) );
         nr_of_columns=k;
         /* print headline */
         fprintf(sim_out[file_nr],"#1:TIME ");
         for (i=1;i<=nr_of_columns;i++) 
          fprintf(sim_out[file_nr],"%d:%s ",i+1,out_label[unit][i]);
         fprintf(sim_out[file_nr],"\n#\n");

      if (a) printf("printer:%d number of inputs:%d\n",unit,nr_of_columns);

      deriv_n[unit][1]=deriv_o[unit][1]=nr_of_columns;
      deriv_n[unit][2]=deriv_o[unit][2]=0; /* reset time-counter */
      deriv_n[unit][3]=deriv_o[unit][3]=0; /* reset nr_of_mean */
      
      if ( (int) par[unit][3]==0 && ( par[unit][2]<= 0 ) )
       { printf(" set time_intervall par2 for printer unit :%d\n",unit);
         exit (-1);
       }
      /* return (1);  return if init, don't inc counters at step 0 */
    }
  nr_of_mean=deriv_n[unit][3]=deriv_o[unit][3]+1; /* nr_of_mean ++ */
  nr_of_columns=(int) deriv_o[unit][1];
  /* deriv_n[unit][2]=deriv_o[unit][2]+h;   inc time-counter later set*/
  
  /*----------------------------------proof time-intervall */
  switch ( (int) par[unit][3] )
    {
      case 0:
        deltaT =par[unit][2];        /*time_intervall*/
        if (a) printf("deltaT printer=%.2f time-counter:%.2f tsim:%.2f\n"
                     ,deltaT,deriv_o[unit][2],tsim);
        if (deriv_o[unit][2]>=deltaT)
            print_flag=1;
        break;
      case 1:                        /* year  */
        print_flag=stop_flag;
        break;
      case 2:                        /*month */
        if (  (day_flag) && (day==01) )  print_flag=1;
        break;
      case 3:                         /*week */
        if (week_flag) print_flag=1;
        break;
      case 4:                         /* day */
        if (day_flag) print_flag=1;
        break;
      case 5:                        /* hour */
        if (hour_flag) print_flag=1;
        break;
      case 6:                        /* min10 */
        if (min10_flag) print_flag=1;
        break;
      case 7:                        /* min */
        if  (!sec) print_flag=1;
        break;
      case 8:                 /* every time_step */
        print_flag=1;
        break;
      default: 
        printf("wrong parameter3 in printer-unit:%d\n",unit);
        exit (-1);
    }
  print_flag=(stop_flag || print_flag); /* force print at end of simulation */
        
  /* chriwi !!!! moved sum of inputs !!! */

  /*----------------------------------------print in file ---------*/
  if ( (print_flag)  ) /* no init values */
    {
      if (a) printf("now print to sim_out: counter:%.2f\n"
                    "nr_of_columns%d\n"
                    ,deriv_o[unit][2],nr_of_columns);

      deriv_n[unit][3]=deriv_o[unit][3]=0; /* reset nr_of_mean */
      deriv_n[unit][2]=deriv_o[unit][2]=0; /* reset time-counter */

      /*---------------------- print time in 1st column */
      switch ( (int) par[unit][4] )
       {
        case 0: /* if par4==0 time=Y/M/D/H/M/S */
                if (year_start<10) fprintf(sim_out[file_nr],"0");
                fprintf(sim_out[file_nr],"%d",year_start);
                if (month<10) fprintf(sim_out[file_nr],"0");
                fprintf(sim_out[file_nr],"%d",month);
                if (day<10)   fprintf(sim_out[file_nr],"0");
                fprintf(sim_out[file_nr],"%d",day);
                if (hour<10)  fprintf(sim_out[file_nr],"0");
                fprintf(sim_out[file_nr],"%d",hour);
                if (min<10)   fprintf(sim_out[file_nr],"0");
                fprintf(sim_out[file_nr],"%d",min);
                if (sec<10)   fprintf(sim_out[file_nr],"0");
                fprintf(sim_out[file_nr],"%d ",sec);
                break;
         case 1: /* tsim sec */ 
               fprintf(sim_out[file_nr],"%d ",(int) tsim+86400*(day_of_year-1));
               break;
         case 2: /* hour h */
               fprintf(sim_out[file_nr],"%f ",(tsim+86400*(day_of_year-1))/ 3600);
               break;
         case 3: /* day d */
               fprintf(sim_out[file_nr],"%f ",(tsim+86400*(day_of_year-1))/(3600*24));
               break;
         case 4: /* month m */
               fprintf(sim_out[file_nr],"%f ",(tsim+86400*(day_of_year-1))/(3600*24*30.42));
               break;
         default:
               printf("wrong par 4 in unit %d\n",unit);
               exit (-1);
        }

    if (a) printf("printer%d nr_of_columns:%d \n"
                  ,(int) par[unit][1],nr_of_columns);

    for (k1=1;k1<=nr_of_columns;k1++)
          {
          if (k1>=6) k=k1+3; /* don't write to out6,7,8 !! */
          else       k=k1;
        
          if (a) printf("printer%d column:%d with init:%.0f   "
                        ,(int) par[unit][1],k1,out_n[unit][k+OUT_MAX0]);

       switch ( (int) out_n[unit][k1+OUT_MAX0] )
         {
        case 0:         /* meanvalue */
               out_o[unit][k]/=nr_of_mean;
               break;
        case 1:      /* current value */
               out_o[unit][k]=out_n IN(k1) ;
               break;
        case 2:      /* integral of time-intervall */
               out_o[unit][k]*=h; /* --> Ws */
               if ( (int) par[unit][5] ) out_o[unit][k]/=3.6e+6;   /* kWh-flag */
           break;
        case 3:      /* sum of all values in timeintervall */
                /* out_n[unit][k] there's already the sum */
               if ( (int) par[unit][5] ) out_o[unit][k]/=3.6e+6;   /* kWh-flag */
               break;

#if 0
           /*------------------------------differences-----------*/
        case 20:     /*meanvalue from differences to following column*/
               out_n[unit][k]=(  out_n[unit][k+1]-out_n[unit][k  ] )/nr_of_mean;
               break;
        case 21:     /* current value */
               out_n[unit][k]= out_n[ in_u [unit][k1+1] ]
                                [ in_nr[unit][k1+1] ]
                          -out_n[ in_u [unit][k1  ] ]
                                [ in_nr[unit][k1  ] ];
               break;
        case 22:         /* integral of time-intervall */
               out_n[unit][k]=(  out_n[unit][k+1]
                                        -out_n[unit][k  ] )*h;
               if ( (int) par[unit][5] ) out_n[unit][k]/=3.6e+6;   /* kWh-flag */
           break;
            case 23:         /* sum of all values in timeintervall */
               out_n[unit][k]=(  out_n[unit][k+1]
                                -out_n[unit][k  ] );
               if ( (int) par[unit][5] )    /* kWh-flag */
                 out_n[unit][k]/=3.6e+6;
               if (a)
               {
               printf("sum of all values in timeintervall:%.2f \n"
                      ,out_n[unit][k]);
               printf("   -->unit13,mpWW:%.2f \n",out_o[13][4]*3600);
               printf("   -->unit13,Q_WW:%.2f \n",out_o[13][3]);
               }
               break;
#endif
            default:
               printf("wrong init-value in unit %d\n"
                      "init-value:%d  nr_of_columns:%d \n"
                      ,unit,(int) out_n[unit][k+OUT_MAX0],nr_of_columns);
               exit (-1);
        }

        if (a) printf("sim_out[printer:%d],%.1f \n",file_nr,out_o[unit][k]);
        /*fprintf(sim_out[file_nr],"%+5.6e ",out_o[unit][k]);*/
        fprintf(sim_out[file_nr],"%f ",out_o[unit][k]);/* + e==>f, EXCEL*/
        out_o[unit][k]=0;            /* reset mean-values */
        } /* end for k1 */
        
      fprintf(sim_out[file_nr],"\n");
      if (fflushFlag) fflush(sim_out[file_nr]);
    }

/*-------------------------------------- sums of th inputs---*/
/* evaluate sum */
if (a) printf("tsim:%.1f \n",tsim);
i_total[file_nr]++;
for (k1=1;k1<=nr_of_columns;k1++) {
 if (k1>=6) k=k1+3; /* don't write to out6,7,8 !! */
 else       k=k1;
 out_n[unit][k]=out_o[unit][k]+out_n IN(k1);
 if (min_total[file_nr][k]>out_n IN(k1)) min_total[file_nr][k]=out_n IN(k1);
 if (max_total[file_nr][k]<out_n IN(k1)) max_total[file_nr][k]=out_n IN(k1);
 sum_total[file_nr][k]+=out_n IN(k1);
 if (a) printf("i:%d in:%.1f sum_total:%.1f i_total:%d\n"
              ,k,out_n IN(k1),sum_total[file_nr][k],i_total[file_nr]);
 }

 /* time counter separate in printer --------------*/
 deriv_n[unit][2]=deriv_o[unit][2]+h;         /* inc time-counter */

 if (stop_flag) fclose(sim_out[file_nr]);
/* --------------------------------write sim_outXX_total.dat ------------------------*/
 if (stop_flag) { 
   double mean_total,integral_total;
   char file_name[30];
   char alorithm[30] ;
   FILE *fd;
   sprintf(file_name,"sim_out%d_total.dat",file_nr);
   if ((fd=fopen(file_name,"w")) == NULL)
      { printf("datafile '%s' open error \n",file_name);exit(-1); }

   printf("------------------------------------printer:%d\n",file_nr);
   for (k1=1;k1<=nr_of_columns;k1++) { if (k1>=6) k=k1+3;else k=k1;
   mean_total=sum_total[file_nr][k]/(double) i_total[file_nr];
   integral_total=sum_total[file_nr][k]*h;
   printf("input:%2d min:%.2f max:%.2f mean:%.2f sum:%.2f integr:%.2f i_total:%d sum:%.1f\n",
     k1,min_total[file_nr][k],max_total[file_nr][k],mean_total,sum_total[file_nr][k],
     integral_total,i_total[file_nr], sum_total[file_nr][k] );

   fprintf(fd,"##### input: %2d  %s \n  min: %.2f \n  max: %.2f\n",k1,out_label[unit][k1],
     min_total[file_nr][k],max_total[file_nr][k] );
   fprintf(fd,"  mean:%5.2f \n",mean_total);
   if ((int) out_n[unit][k1+OUT_MAX0]==3) fprintf(fd,"  sum: %.2f\n",sum_total[file_nr][k] );
   fprintf(fd,"  time_intervall:%.1f sec\n",i_total[file_nr]*h );
   switch ( (int) out_n[unit][k1+OUT_MAX0] ) {
    case 0: sprintf(alorithm,"MEAN"); break;
    case 1: sprintf(alorithm,"CURR"); break;
    case 2: sprintf(alorithm,"INTE"); 
            fprintf(fd,"  integral: %.2f [Ws] = %.2f [kWh]\n",
              integral_total,integral_total/3.6e+6);
            break;
    case 3: sprintf(alorithm,"SUM "); break;
    default: printf("printer[%d] alorithm error:%d\n",unit,
             (int) out_n[unit][k1+OUT_MAX0] ); exit (-1);
   }
   fprintf(fd,"type: %s\n",alorithm);

   }
 fclose(fd);
 } /* end stop_flag */

return 1;
}

