/*  rad_processor.h   ColSim,Christof Wittwer FhG-ISE FBTA                    */
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/
/* this file is used for defines for rad_proc2() in rad_processor.c */

/*
010608 first use
010827 struct radiation_struct added
010920 rad_proc2: double *timezone added
011016 radiation_struct moved to here (rad_processor.h)

*/

#define IGH_IDH 1
#define IGT_MES 2
#define IGT_IGH 3
#define IGH_IBN 4
#define IGH_MES 5

#define TIMER_SET_FOR_SKY 60 /* x seconds for recalculation */


int rad_proc2(struct sim_struct *info,            /* see interface.h */
              struct interface_struct *interface, /* see interface.h */
              struct radiation_struct *radiation); /* see above */

int rad_processor(double tsim,int day_of_year,double Ib_hor, double Id_hor
                  ,double rho_g,double E_40,double slope,double orientation
                  ,double *out,double *lenght,double *latitude,double Rd
                  ,double Rr);
#if 0     /* see global.h */
int rad_proc2(struct sim_struct *info,
              struct radiation_struct *radiation,
              double *Ibt,double *Idt,
              double *Igt,double *out,
              double Igh,double Idh,double Ibn,double Igt_mess,
              int mode,int init_flag,double tsim,double h,int day_of_year,
              int horizon_nr,double b0,double iam_diff,
              double slope,double orientation,double *timezone,
              double *lenght,double *latitude,
              double rho_g,int unit);
#endif
