/*
type_call.orig.c 
!!! auto modified by cfg/config --> type_call.c 

 * Copyright (C) 1995  Christof Wittwer
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
*/

/*
001109 type_call argument out_label included
010517 i_dead_no erased
010627 skip_time_intervall,**thermo_struct added to type_call()
010827 sim_struct added
010920 timezone added to args of type_call
010925 rad_processor.h included
*/
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "global.h"
#include "rad_processor.h"

int type_call(
              struct sim_struct *info, /* see global.h */
              struct interface_struct *interface,
              struct radiation_struct *radiation,
              char **type_def_str,
              int unit,
              int un_max,
              int *type,
              int *select_unit,
              int *type_index, 
              int init_flag,
              double *timezone,
              double *lenght,
              double *latitude,
              int day_of_year,
              int year_start,
              int month,
              int day,
              int hour,
              int min,
              int sec,
              int day_flag,
              int hour_flag,
              int week_flag,
              int day_of_week,
              int min10_flag,
              int stop_flag,
              int previous_unit,
              int **in_u,
              int **in_nr,
              double **iam,
              double h,
              double tsim,
              double **par,
              double **out_n,
              double **out_o,
              double **deriv_o,
              double **deriv_n,
              double **init_energy,
              double **Qi,
              double **Q, /* pipe */
              double ***qp_sum,
              int    a,
              int    *unit_order,
              int    nr_of_unit_calls,
              double **dummy,
              char ***out_label,
              double skip_time_intervall,
              struct therm_hydraulic_struct **thermo_struct
             )
{

static int init_local_flag=1;
int unix_flag=1;
int check=0;


if (init_local_flag) {
 init_local_flag=0;
 }

			
switch (type[unit])  
  { 
  case 0:
    break;
  /* ###### BEGIN CASE_LOOP ### don't erase this pattern !!!!!##############*/
 case 1: /* TYPE */ 
     check=collector (info,interface,radiation,unit,par,in_u,in_nr,out_o,
              out_n,deriv_o,deriv_n,h,init_energy,
              qp_sum,tsim,init_flag,
              day_of_year,un_max,lenght,latitude,iam);
     break;
 case 2: /* TYPE */ 
     check=controller ( unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
               qp_sum,tsim,init_flag);
     break;
 case 3: /* TYPE */ 
     check=pump (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,qp_sum,
         tsim,init_flag,previous_unit,select_unit,type_index,thermo_struct);
     break;
 case 4: /* TYPE */ 
     check=storage  (unit,par,in_u,in_nr,out_n,out_o,deriv_o,deriv_n,h,
             init_energy,qp_sum,tsim,init_flag,type,day_of_year,
             previous_unit,un_max,select_unit,type_index);
     break;
 case 5: /* TYPE */ 
     check=water_drop (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
               qp_sum,tsim,init_flag);
     break;
 case 6: /* TYPE */ 
     check=heater (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
           qp_sum,tsim,init_flag);
     break;
 case 8: /* TYPE */ 
     check=heating (unit,par,in_u,in_nr,out_n,out_o,deriv_o,deriv_n,h,
            init_energy,qp_sum,tsim,init_flag,Q,
            un_max);
     break;
 case 9: /* TYPE */ 
     check=weather (info,radiation,tsim,h,unit,par,out_o,out_n,year_start,
            month,day,day_flag);
     break;
 case 10: /* TYPE */ 
     check=heatexchanger (unit,par,in_u,in_nr,out_n,out_o,deriv_o,deriv_n,h,
		  init_energy,qp_sum,tsim,init_flag,previous_unit,select_unit);
     break;
 case 11: /* TYPE */ 
     check=diverter (unit,par,in_u,in_nr,out_o,out_n,init_flag);
     break;
 case 12: /* TYPE */ 
     check=heatpump (unit,par,in_u,in_nr,out_o,out_n, h, qp_sum, init_flag);
     break;
 case 13: /* TYPE */ 
     check=mixer (unit,par,in_u,in_nr,out_o,out_n,h,init_flag);
     break;
 case 14: /* TYPE */ 
     check=load (unit,par,out_o,out_n,tsim,day_of_year,day_of_week,skip_time_intervall);
     break;
 case 15: /* TYPE */ 
     check=load_control (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
               qp_sum,tsim,init_flag);
     break;
 case 20: /* TYPE */ 
     check=zone (unit,par,in_u,in_nr,out_n,out_o,deriv_o,deriv_n,h,init_energy,
         qp_sum,tsim,init_flag,day_of_year,lenght,latitude,type);
     break;
 case 23: /* TYPE */ 
     check=RC (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
              qp_sum,tsim,init_flag);
     break;
 case 24: /* TYPE */ 
     check=equation (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
             qp_sum,tsim,init_flag,day_of_year);
     break;
 case 25: /* TYPE */ 
     check=printer (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,tsim,init_flag,
            year_start,day_of_year,month,day,hour,min,sec,day_flag,week_flag,
            hour_flag, min10_flag,stop_flag,un_max,out_label,type_index);
     break;
 case 26: /* TYPE */ 
     check=controller_x ( unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
               qp_sum,tsim,init_flag);
     break;
 case 27: /* TYPE */ 
     check=equation_x (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
             qp_sum,tsim,init_flag,day_of_year);
     break;
 case 28: /* TYPE */ 
     check=wall ( info,interface,radiation,unit,par,in_u,in_nr,out_n,out_o,
          deriv_o,deriv_n,h,
          init_energy,qp_sum,tsim,init_flag,type,
          day_of_year,timezone,lenght,latitude,iam,type_index
         );
     break;
 case 29: /* TYPE */ 
     check=AirRad_node (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,
                init_energy,qp_sum,tsim,init_flag,day_of_year,lenght,
                latitude,type);
     break;
 case 31: /* TYPE */ 
     check=pipe2 (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,qp_sum,
          tsim,init_flag,dummy);
     break;
 case 32: /* TYPE */ 
     check=pipe_air (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
             qp_sum,tsim,init_flag,type,type_index);
     break;
 case 33: /* TYPE */ 
     check=mass_element (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,
	         h,init_energy,qp_sum,tsim,init_flag,type,day_of_year);
     break;
 case 35: /* TYPE */ 
     check=hydraulic  (unit, par, in_u, in_nr, out_o, out_n, deriv_o, deriv_n, h,
               init_energy, qp_sum, tsim, init_flag, type, unit_order,
               nr_of_unit_calls);
     break;
 case 36: /* TYPE */ 
     check=valve (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,qp_sum,
          tsim,init_flag,select_unit,type_index);
     break;
 case 38: /* TYPE */ 
     check=HydResist (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,qp_sum,
          tsim,init_flag);
     break;
 case 47: /* TYPE */ 
     check=diverter_air (unit,par,in_u,in_nr,out_o,out_n,init_flag,select_unit);
     break;
 case 48: /* TYPE */ 
     check=mixer_air (unit,par,in_u,in_nr,out_o,out_n,h,init_flag,select_unit);
     break;
 case 49: /* TYPE */ 
     check=pump_air (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
             qp_sum,tsim,init_flag,previous_unit,select_unit);
     break;
 case 50: /* TYPE */ 
     check=heater_air (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
               qp_sum,tsim,init_flag);
     break;
 case 57: /* TYPE */ 
     check=rotation_ex (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,init_energy,
                qp_sum, tsim,init_flag,previous_unit,select_unit,type_index);
     break;
 case 60: /* TYPE */ 
     check=heatexchanger_air (unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h,
                     init_energy,qp_sum,tsim,init_flag);
     break;
 case 61: /* TYPE */ 
     check=shading (info,interface,radiation);
     break;
 case 65: /* TYPE */ 
     check=gnu_plotter (unit,par,in_u,in_nr,out_o,out_n,h,tsim,init_flag,
                stop_flag,unix_flag,day_of_year,out_label);
     break;
  default:
       printf("unknown TYPE:%d unit:%d exit\n",type[unit],unit);exit (-1);
     } /*case-end*/


return (check);
}
 /* end of type_call() */