/* unit_order_init.c
 check=unit_order_init(0,parameter,input_unit,input_out_nr,
           out_present,out_past,deriv_o,deriv_n,h,init_energy,
           qp_sum,tsim,init_flag,type_def_str,type,unit_max);

*/

/*
001025 no energy-balance (out6,7,8) check for types PRIORITY 5...14
       scan hydraulic types sence hydraulic coupling
010501 first_model_index,last_model_index included for FastIteration mode
010517 80 columns limitation 
*/

#include "global.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------unit_order_init --------------------*/
int unit_order_init(unit,par,in_u,in_nr,out_o,out_n,deriv_o,deriv_n,h
                   ,init_energy,qp_sum,tsim,init_flag,type_def_str
                   ,type,unit_max,unit_order,first_model_index
                   ,last_model_index)
           int    unit;      /* current unit number */
           double **par;     /* parameter array par[unit][1..PARMAX]  */
           int    **in_u;    /* input unit array, input connections   */
           int    **in_nr;   /* input number array                    */
           double **out_o;   /* output array with privious state      */
           double **out_n;   /* output array with current state       */
           double **deriv_o; /* derivatives: used for diffential equ. */
           double **deriv_n; /*  new state of deriv                   */
           double h;         /* sim time step                         */
           double **init_energy; /* initial energy in RC-comp. [Ws]   */
           double ***qp_sum; /* energy to one node qp[unit][n][m]     */
           double tsim;      /* simulation time in [s] of this day    */
           int    init_flag; /* set at initial loop of sim            */
           char   **type_def_str;
           int    *type; 
           int    unit_max;  /*            */
           int    *unit_order;
           int    *first_model_index; /* FastIteration setting */
           int    *last_model_index;  /* FastIteration setting */

{
/*  
    TYPE 03
    PRIORITY  5          used by config routine: pump priority
    HYDRAULIC 1          pump fluid
*/

int a=0; /* chriwi's debug */
int select_unit[UNIT_MAX]; /* selections */
int i_unit=0,i=0,i1;
int pump_nr=0;
int pump_unit[UNIT_MAX];
int coll_pipe_nr;
int coll_pipe_unit[UNIT_MAX];
int i_div;
int div_unit[UNIT_MAX];
int mp_change;
int **active_circle; /* order of units set by set_mp() */
int k;
int nr_of_circles;
int nr_of_unit_calls=0;
int hydraulic_type_unit[UNIT_MAX];

#include "unit_order_init.h"

if (a) printf("unit_order_init: unit_max:%d\n",unit_max);
for (i=1;i<=unit_max;i++) hydraulic_type_unit[i]=hydraulic_type[type[i]];

active_circle  =malloc_2int(PUMP_NR+1 ,UNIT_MAX+1);

for (i=1;i<=unit_max;i++) select_unit[i]=0; /* reset selecting flag */
for (i=1;i<=unit_max;i++) if (type[i]==62) select_unit[i]=1; /* occupied */


/* !no energy-balance (out6,7,8) check for types PRIORITY 5...14 ,
    energy_outcome.c*/
  /* weather_read,load */
for (i=1;i<=unit_max;i++) if ( (priority[ type[i] ]==1) && (select_unit[i]==0) )
 {i_unit++;unit_order[i_unit]=i;select_unit[i]=1; 
  if (a) printf("unit:%d found\n",i);
 }

  /* 2nd priority not yet used */
for (i=1;i<=unit_max;i++) if ( (priority[ type[i] ]==2) && (select_unit[i]==0) )
 {i_unit++;unit_order[i_unit]=i;select_unit[i]=1; 
  if (a) printf("unit:%d found\n",i); 
 }
  /* controller */
for (i=1;i<=unit_max;i++) if ( (priority[ type[i] ]==3) && (select_unit[i]==0) )
 {i_unit++;unit_order[i_unit]=i;select_unit[i]=1; 
  if (a) printf("unit:%d found\n",i); }
  /* priority 4 */
for (i=1;i<=unit_max;i++) if ( (priority[ type[i] ]==4) && (select_unit[i]==0) )
 {i_unit++;unit_order[i_unit]=i;select_unit[i]=1;
  if (a) printf("unit:%d found\n",i);}

  /* pump and fan */
for (i=1;i<=unit_max;i++) 
 if  ( (priority[ type[i] ]==5) && (select_unit[i]==0) )
  {
   if (a) printf("unit:%d pump found\n",i);
   *first_model_index=i_unit+1; /* get pump or fan for FastIteration mode*/ 
   select_unit[i]=1;
   pump_nr++;
   pump_unit[pump_nr]=i;
   if (a) printf("unit_order_init: pump or fan found: "
                 "unit:%d pump_unit[%d]:%d priority[%d]:%d\n"
       ,i,pump_nr,pump_unit[pump_nr],i,priority[i]);
  }
 /* hydraulic */
if (a) for (i=1;i<=i_unit;i++) 
         printf("unit_order[%d]=%d type:%d \n",i,unit_order[i],type[i]);
 /* nr_of_circles could be less then nr of pumps !!! */
if (a) printf("calling 'init_set_mp.c' ");
nr_of_circles=init_set_mp(par,in_u,in_nr,out_o,out_n,hydraulic_type_unit,
               pump_nr,pump_unit,coll_pipe_nr,coll_pipe_unit,tsim,unit_max,
               type_def_str,i_div,div_unit,mp_change,init_flag,
               active_circle);
 if (a) printf(" ... passed\n");

/*-----------store order in array 'unit_order[]'--------------------- */
for (k=1;k<=nr_of_circles;k++)
{
 for (i=1;i<=(unit_max+30);i++) /* go through active_circle list */
 {
 if (active_circle[k][i]==0) break;
 i_unit++;
 unit_order[i_unit]=active_circle[k][i]; /*put unit_nr on unit_order[]*/
 *last_model_index=i_unit; /* count up from here */
 if (a) printf("last_model_index prior:%d\n",i_unit);
 select_unit[ active_circle[k][i] ]=1; /* occupied */
 }
}
for (i1=6;i1<=99;i1++) /* non hydraulics , or non-selected units */
 {

 for (i=1;i<=unit_max;i++) 
   if  ( (priority[ type[i] ]==i1) && (select_unit[i]==0) ) {
    i_unit++;unit_order[i_unit]=i;select_unit[i]=1;
    if (a) printf("unit:%d found\n",i); 
    if (*first_model_index==0)  *first_model_index=i_unit; /*NonHydr System */
    if (priority[ type[i] ]<12) *last_model_index=i_unit; /* before plotters */
   }
 }

/* check nr of unit-calls of timestep ()!!:more then unmax!!---*/
if (a) printf("unit_order_init: -------------------------unit_order \n");
if (a) printf("%d: unit_max:%d nr_of_unit_calls:%d\n"
              ,i,unit_max,nr_of_unit_calls);
i=0;

do
 {
 i++;
/* if (unit_order[i]==0) break; */

  if (a)
  printf("unit_order%d: \t unit:%d \t type:%d \t%s priority:%d\n"
        ,i,unit_order[i],type[unit_order[i]],type_def_str[ type[unit_order[i]] ]
        ,priority[ type[unit_order[i]] ] );

if (a) fflush(stdout);
 nr_of_unit_calls++;
 }
while ( (unit_order[i+1]!=0) && (i<UNIT_MAX) );

if (a) printf("\n nr_of_unit_calls:%d \n",nr_of_unit_calls);
if (a) fflush(stdout);

if (a) printf("first_model_index:%d \n",*first_model_index);
if (a) printf("last_model_index:%d \n",*last_model_index);

return (nr_of_unit_calls);
}

